



/* Hexavirus code for CPC */
/* permission granted by Mollusck to make a CPC version */

// if you want to reloc areas, make them .ds
// if you make them .db then it will try to initialise and make binary bigger
// areas I can use:
// 0040-0187
// 0800-0987
// 1000-1187
// 1800-1987
// 2000-2187
// 2800-2987
// 3000-3187
// 3800-3987
// 4564-4800
// 6d64-5000
// 6664-5800
// 6d64-6000		
// 6564-6800		// 6d64 letter buffer
// 6d64-7000		// 6d64 is scr table
// 7564-7800		// 6fe0 is keymap, 7700-7800 is spr mask
// 7d64-ffff		// main area (stack at end) - need to allow for paging in/out asic stuff

// 528 bytes needed for screen table


/* bugs:
choice of levels OR random

CRTC_R1 = 46			;; normally 40
CRTC_R9 = 8
CRTC_R6 = 33			;; normally 25
SCR_HEIGHT_PIXELS = CRTC_R9*CRTC_R6
SCR_WIDTH_BYTES = CRTC_R1*2
SCR_BASE = 0x188		;; normally 0xc000
LETTER_HEIGHT = 8

*/

extern unsigned char plus;

//#include "cpcrslib.h"
//#include "morelib.h"
//#include "lib/starkos/starkos.h"
#define DO_MOVES_REMAINING
#define OVERSCAN
#include "mylib.h"
#include "ArkosPlayer2.h"
#include "pluslib.h"
#include "playcity.h"

#include "gfx/bin/hexatiles.h"

#ifdef OTHER_TILES
#include "gfx/bin/recttiles.h"
#include "gfx/bin/tritiles.h"
#endif
#include "gfx/bin/logo.h"
#include "gfx/bin/legend.h"
#include "gfx/bin/select.h"
#include "gfx/bin/numbers.h"
#include "gfx/bin/font.h"
#include "gfx/bin/gamepal.h"

void set_main_state_game();

// to fool sdcc, pretend they are 1 element arrays when in reality they are larger.
extern const unsigned char silence_music[1];
extern const unsigned char move_music[1];
extern const unsigned char menu_music[1];
extern const unsigned char game_start_music[1];
extern const unsigned char completed_music[1];
extern const unsigned char game_over_music[1];
extern const unsigned char ingame_music[1];
extern const unsigned char selected_music[1];

//#define grid_width 9
//#define grid_height 18


  #define LOGO_NUM_SPRITES 14


#define CLR_COLOUR (CPC_PEN1_MODE0|(CPC_PEN1_MODE0<<1))
#define BACK_COLOUR (CPC_PEN0_MODE0|(CPC_PEN0_MODE0<<1))

#define STAT_MENU_Y 12

#define STAT_MENU_X 8

#define BYTES_PER_CHAR 2
#define LINES_PER_CHAR 8

#define SCR_HEIGHT_CHARS (SCR_HEIGHT_PIXELS/LINES_PER_CHAR)
#define SCR_WIDTH_CHARS (SCR_WIDTH_BYTES/2)

// define dimensions in chars
#define CREDITS_RECT_WIDTH 20
#define CREDITS_RECT_WIDTH_BYTES (CREDITS_RECT_WIDTH*BYTES_PER_CHAR)
#define CREDITS_CX ((SCR_WIDTH_CHARS/2)-(CREDITS_RECT_WIDTH/2))
#define CREDITS_CY 16
#define CREDITS_RECT_X SCR_CHAR_TO_BYTEX0((CREDITS_CX))
#define CREDITS_RECT_Y SCR_CHAR_TO_LINEY0((CREDITS_CY))
#define CREDITS_RECT_HEIGHT (5*LINES_PER_CHAR)

#define INSTRUCTIONS_RECT_WIDTH 34
#define INSTRUCTIONS_RECT_WIDTH_BYTES (INSTRUCTIONS_RECT_WIDTH*BYTES_PER_CHAR)
#define INSTRUCTIONS_RECT_CX ((SCR_WIDTH_CHARS/2)-(INSTRUCTIONS_RECT_WIDTH/2))
#define INSTRUCTIONS_RECT_CY 7
#define INSTRUCTIONS_RECT_X SCR_CHAR_TO_BYTEX0((INSTRUCTIONS_RECT_CX))
#define INSTRUCTIONS_RECT_Y SCR_CHAR_TO_LINEY0((INSTRUCTIONS_RECT_CY))
#define INSTRUCTIONS_RECT_HEIGHT (17*LINES_PER_CHAR)

#define CENTRALISE_RECT_WIDTH 28
#define CENTRALISE_RECT_WIDTH_BYTES (CENTRALISE_RECT_WIDTH*BYTES_PER_CHAR)
#define CENTRALISE_RECT_CX ((SCR_WIDTH_CHARS/2)-(CENTRALISE_RECT_WIDTH/2))
#define CENTRALISE_RECT_HEIGHT_CHARS 6
#define CENTRALISE_RECT_HEIGHT (CENTRALISE_RECT_HEIGHT_CHARS*LINES_PER_CHAR)
#define CENTRALISE_RECT_CY ((SCR_HEIGHT_CHARS/2)-(CENTRALISE_RECT_HEIGHT_CHARS/2))
#define CENTRALISE_RECT_X SCR_CHAR_TO_BYTEX0((CENTRALISE_RECT_CX))
#define CENTRALISE_RECT_Y SCR_CHAR_TO_LINEY0((CENTRALISE_RECT_CY))


#define PLEASE_WAIT_RECT_WIDTH 20
#define PLEASE_WAIT_RECT_WIDTH_BYTES (PLEASE_WAIT_RECT_WIDTH*BYTES_PER_CHAR)
#define PLEASE_WAIT_RECT_CX ((SCR_WIDTH_CHARS/2)-(PLEASE_WAIT_RECT_WIDTH/2))
#define PLEASE_WAIT_RECT_CY 5
#define PLEASE_WAIT_RECT_X SCR_CHAR_TO_BYTEX0((PLEASE_WAIT_RECT_CX))
#define PLEASE_WAIT_RECT_Y SCR_CHAR_TO_LINEY0((PLEASE_WAIT_RECT_CY))
#define PLEASE_WAIT_RECT_HEIGHT (3*LINES_PER_CHAR)


#define LEVEL_RECT_WIDTH 31
#define LEVEL_RECT_WIDTH_BYTES (LEVEL_RECT_WIDTH*BYTES_PER_CHAR)
#define LEVEL_RECT_CX ((SCR_WIDTH_CHARS/2)-(LEVEL_RECT_WIDTH/2))
#define LEVEL_RECT_CY 5
#define LEVEL_RECT_X SCR_CHAR_TO_BYTEX0((LEVEL_RECT_CX))
#define LEVEL_RECT_Y SCR_CHAR_TO_LINEY0((LEVEL_RECT_CY))
#define LEVEL_RECT_HEIGHT (4*LINES_PER_CHAR)

#define TITLE_CX 23
#define TITLE_CY 11


#define MAIN_MENU_RECT_WIDTH 20
#define MAIN_MENU_RECT_WIDTH_BYTES (MAIN_MENU_RECT_WIDTH*BYTES_PER_CHAR)
#define MAIN_MENU_CX ((SCR_WIDTH_CHARS/2)-(MAIN_MENU_RECT_WIDTH/2))
#define MAIN_MENU_CY 22
#define MAIN_MENU_RECT_X SCR_CHAR_TO_BYTEX0((MAIN_MENU_CX))
#define MAIN_MENU_RECT_Y SCR_CHAR_TO_LINEY0((MAIN_MENU_CY))
#define MAIN_MENU_RECT_HEIGHT (6*LINES_PER_CHAR)

#if 0
#define EXIT_QUESTION_RECT_WIDTH 8
#define EXIT_QUESTION_RECT_WIDTH_BYTES (EXIT_QUESTION_RECT_WIDTH*BYTES_PER_CHAR)
#define EXIT_QUESTION_RECT_CX ((SCR_WIDTH_CHARS/2)-(EXIT_QUESTION_RECT_WIDTH/2))
#define EXIT_QUESTION_RECT_CY 10
#define EXIT_QUESTION_RECT_X SCR_CHAR_TO_BYTEX0((EXIT_QUESTION_RECT_CX))
#define EXIT_QUESTION_RECT_Y SCR_CHAR_TO_LINEY0((EXIT_QUESTION_RECT_CY))
#define EXIT_QUESTION_RECT_HEIGHT (3*LINES_PER_CHAR)

#define EXIT_MENU_RECT_WIDTH 6
#define EXIT_MENU_RECT_WIDTH_BYTES (EXIT_MENU_RECT_WIDTH*BYTES_PER_CHAR)
#define EXIT_MENU_RECT_CX ((SCR_WIDTH_CHARS/2)-(EXIT_MENU_RECT_WIDTH/2))
#define EXIT_MENU_RECT_CY EXIT_QUESTION_RECT_CY+8
#define EXIT_MENU_RECT_X SCR_CHAR_TO_BYTEX0((EXIT_MENU_RECT_CX))
#define EXIT_MENU_RECT_Y SCR_CHAR_TO_LINEY0((EXIT_MENU_RECT_CY))
#define EXIT_MENU_RECT_HEIGHT (4*LINES_PER_CHAR)
#endif

#define PLAY_MENU_RECT_HEIGHT (6*LINES_PER_CHAR)

#define MAIN_MENU_SCR_ADDR SCR_ADDR_FROM_COORD(MAIN_MENU_RECT_X,MAIN_MENU_RECT_Y)

#define PAUSE_MENU_RECT_WIDTH 20
#define PAUSE_MENU_RECT_WIDTH_BYTES (PAUSE_MENU_RECT_WIDTH*BYTES_PER_CHAR)
#define PAUSE_MENU_CX 11
#define PAUSE_MENU_CY 12
#define PAUSE_MENU_RECT_X SCR_CHAR_TO_BYTEX0((PAUSE_MENU_CX))
#define PAUSE_MENU_RECT_Y SCR_CHAR_TO_LINEY0((PAUSE_MENU_CY))
#define PAUSE_MENU_RECT_HEIGHT (6*LINES_PER_CHAR)

#define PAUSE_MENU_SCR_ADDR SCR_ADDR_FROM_COORD(PAUSE_MENU_RECT_X,PAUSE_MENU_RECT_Y)



#define AFTER_GAME_MENU_RECT_WIDTH 20
#define AFTER_GAME_MENU_RECT_WIDTH_BYTES (AFTER_GAME_MENU_RECT_WIDTH*BYTES_PER_CHAR)
#define AFTER_GAME_MENU_CX 11
#define AFTER_GAME_MENU_CY 12
#define AFTER_GAME_MENU_RECT_X SCR_CHAR_TO_BYTEX0((AFTER_GAME_MENU_CX))
#define AFTER_GAME_MENU_RECT_Y SCR_CHAR_TO_LINEY0((AFTER_GAME_MENU_CY))
#define AFTER_GAME_MENU_RECT_HEIGHT (8*LINES_PER_CHAR)

#define AFTER_GAME_MENU_SCR_ADDR SCR_ADDR_FROM_COORD(AFTER_GAME_MENU_RECT_X,AFTER_GAME_MENU_RECT_Y)

#define AFTER_GAME_QUESTION_HEIGHT_CHARS 6
#define AFTER_GAME_MENU_QUESTION_RECT_WIDTH AFTER_GAME_MENU_RECT_WIDTH
#define AFTER_GAME_MENU_QUESTION_RECT_WIDTH_BYTES AFTER_GAME_MENU_RECT_WIDTH_BYTES
#define AFTER_GAME_MENU_QUESTION_CX 11
#define AFTER_GAME_MENU_QUESTION_CY (AFTER_GAME_MENU_CY + ((AFTER_GAME_MENU_RECT_HEIGHT/LINES_PER_CHAR)-AFTER_GAME_QUESTION_HEIGHT_CHARS))
#define AFTER_GAME_MENU_QUESTION_RECT_X SCR_CHAR_TO_BYTEX0((AFTER_GAME_MENU_QUESTION_CX))
#define AFTER_GAME_MENU_QUESTION_RECT_Y SCR_CHAR_TO_LINEY0((AFTER_GAME_MENU_QUESTION_CY))
#define AFTER_GAME_MENU_QUESTION_RECT_HEIGHT (AFTER_GAME_MENU_RECT_HEIGHT-(AFTER_GAME_QUESTION_HEIGHT_CHARS*LINES_PER_CHAR))

#define AFTER_GAME_MENU_QUESTION_SCR_ADDR SCR_ADDR_FROM_COORD(AFTER_GAME_MENU_QUESTION_RECT_X,AFTER_GAME_MENU_QUESTION_RECT_Y)
/*#define max(a,b) \
	((a) > (b)) ? (a) : (b)
*/

#define logo_width_bytes (58/2)
#define logo_height_lines 53

#define LOGO_X ((SCR_WIDTH_BYTES/2)-(logo_width_bytes/2))
#define LOGO_Y 32

#define grid_width_rect 20
#define grid_height_rect 16		

// we can't make it 18 unless we make the height of rectangles 12 and make the width 6

//#define grid_height_rect 18

#define grid_width_tri 21
#define grid_height_tri 11
//#define grid_height_tri 2

// 30 is too tall for 32 line screen by 8 lines.
#define grid_width_hex 10
#define grid_height_hex 32

#define max_grid_width 32
#define max_grid_height 32

//#define max_grid_width max(grid_width_rect, max(grid_width_hex, grid_width_tri))
//#define max_grid_height max(grid_height_rect, max(grid_height_hex, grid_height_tri))
#define play_grid_width 32

/* at some point it will become impossible to beat because there is a minimum number of moves */
/* set we don't allow it to go beyond the min, and we give a final well done */
#ifdef DO_MOVES_REMAINING
#define MOVES_MIN 16
#define MOVES_MAX 40  // 39 on virus 3
#endif

//#define MOVES_MAX_RECT 44
//#define MOVES_MIN_RECT 16

//#define MOVES_MAX_TRI 44
//#define MOVES_MIN_TRI 16


//#define twice_grid_width (grid_width*2)


#define number_width 8
#define number_height 16
#define number_width_bytes (number_width/2)
#define number_data_size (number_width_bytes*number_height)

#define number_x (SCR_WIDTH_BYTES-(number_width_bytes*2))
#define number_y 7

#define min_number_x (SCR_WIDTH_BYTES-(number_width_bytes*2))
#define min_number_y 24


#define hex_tile_width 12
#define hex_tile_height 16
#define hex_half_tile_height (hex_tile_height/2)

#define hex_tile_width_bytes (hex_tile_width/2)

#define hex_third_tile_width (hex_tile_width_bytes/3)
#define hex_two_third_tile_width ((hex_tile_width_bytes*2)/3)

#define hex_tile_data_size (hex_tile_width_bytes*hex_tile_height)

#define rect_tile_width 8
#define rect_tile_height 16

#define rect_tile_width_bytes (rect_tile_width/2)

#define rect_tile_data_size (rect_tile_width_bytes*rect_tile_height)

#define tri_tile_width 14		// 14 pixels, 7 bytes
#define tri_tile_height 12	// 12 pixels

#define tri_tile_width_bytes (tri_tile_width/2)

#define tri_tile_data_size (tri_tile_width_bytes*tri_tile_height)

#define tri_half_tile_width (tri_tile_width_bytes/2)


#define select_width 8
#define select_height 16
#define select_width_bytes (select_width/2)
#define select_data_size (select_width_bytes*select_height)

#define select_sprite (select)
#define unselect_sprite (select+select_data_size)


#define legend_width  18
#define legend_height 260
#define legend_width_bytes (legend_width/2)
#define half_legend_height (legend_height/2)

#define legend_x (SCR_WIDTH_BYTES-legend_width_bytes)
#define legend_y (HALF_SCR_HEIGHT_PIXELS-half_legend_height)

#define SELECT_X (legend_x+2)

#define MIN_COLOURS 3
#define MAX_COLOURS 7
int num_colours;

#define MAX_SEL 8

#define TRI_POINT_UP_INDEX (MAX_COLOURS+1)

#define MOVE_SEQUENCE_MAX 128
__at (0x0800) char move_sequence[MOVE_SEQUENCE_MAX];
int move_count;
//int min_move_count;

#define xorg 0
#define yorg 0

enum
{
	TILE_TYPE_HEXAGON = 0,
#ifdef OTHER_TILES
	TILE_TYPE_RECTANGLE,
	TILE_TYPE_TRIANGLE,
#endif
};

#define	TILE_TYPE_MIN TILE_TYPE_HEXAGON
#define TILE_TYPE_MAX (TILE_TYPE_TRIANGLE+1)


enum
{
	SOUND_TYPE_NONE = 0,
	SOUND_TYPE_MUSIC,
	SOUND_TYPE_SFX,
	SOUND_TYPE_MIXED, /* playcity allows mixed */  
};

#define 	SOUND_TYPE_MIN SOUND_TYPE_NONE
#define SOUND_TYPE_MAX (SOUND_TYPE_MUSIC+1)
#define SOUND_TYPE_MAX_PC (SOUND_TYPE_MIXED+1)

#define SOUND_FLAG_SFX (1<<0)
#define SOUND_FLAG_WAIT_FOR_END (1<<1)
#define SOUND_FLAG_ALWAYS (1<<2)

enum
{
  MAIN_STATE_FRONTEND=0,
  MAIN_STATE_GAME,
};

enum
{
	SUB_STATE_MAIN_MENU=0,	// display main menu
	SUB_STATE_PLAY_MENU,	// display play menu
	SUB_STATE_OPTIONS_MENU, // display options menu
	SUB_STATE_PAUSE_MENU,	// display pause menu
	SUB_STATE_EXIT_MENU, // display exit menu
	STATE_WAITING_PLAYER_CHOICE,		// waiting for player to make choice,
	STATE_DRAW_INFECTED_CELL,			// draw infected cell
	STATE_UPDATE_INFECTION,
	STATE_UPDATE_INFECTION_DELAY,
	STATE_SELECT_CHOICE, 
	STATE_CHANGE_CHOICE,
	SUB_STATE_GAME_WON,	// finished game, either successful or not
	SUB_STATE_RESTART,	// perform restart
	SUB_STATE_RESTART_MENU, // show restart menu
	SUB_STATE_QUIT_MENU, // show quit menu
	SUB_STATE_CENTRALISE_SCREEN, // show centralise screen.
	SUB_STATE_QUITTING, // perform quit
	STATE_BACK_TO_GAME, // perforce back to game from menu
	SUB_STATE_TRY_AGAIN, // show try again menu
  SUB_STATE_RESTART_NEW, // restart new game and restart music too
	SUB_STATE_RESTART_OLD, // restart game and restart music too
  SUB_STATE_CONTINUE_AFTER_WIN,
  SUB_STATE_LEVEL_INTRO,
  SUB_STATE_LEVEL_INTRO2,
  SUB_STATE_BEGIN_GAME,
  SUB_STATE_INSTRUCTIONS
};	
 

/***************************************************************/


static const unsigned char blue_pens[4]={
  CPC_PEN1_MODE0&CPC_PIXEL1_MASK_MODE0, // black
  CPC_PEN2_MODE0&CPC_PIXEL1_MASK_MODE0, // blue
  CPC_PEN9_MODE0&CPC_PIXEL1_MASK_MODE0, // sky blue
  CPC_PEN3_MODE0&CPC_PIXEL1_MASK_MODE0, // bright blue
  };
   
static const unsigned char red_pens[4]={
  CPC_PEN1_MODE0&CPC_PIXEL1_MASK_MODE0, // black
  CPC_PEN4_MODE0&CPC_PIXEL1_MASK_MODE0, // red
  CPC_PEN12_MODE0&CPC_PIXEL1_MASK_MODE0, // orange
  CPC_PEN6_MODE0&CPC_PIXEL1_MASK_MODE0, // bright red
  };
    
static const unsigned char green_pens[4]={
  CPC_PEN1_MODE0&CPC_PIXEL1_MASK_MODE0, // black
  CPC_PEN2_MODE0&CPC_PIXEL1_MASK_MODE0, // blue
  CPC_PEN13_MODE0&CPC_PIXEL1_MASK_MODE0, // sea green
  CPC_PEN8_MODE0&CPC_PIXEL1_MASK_MODE0, // dark green
  };
 
   
static const unsigned char title_pens[4]={
  CPC_PEN10_MODE0&CPC_PIXEL1_MASK_MODE0, // grey
  CPC_PEN8_MODE0&CPC_PIXEL1_MASK_MODE0, // dark green 
  CPC_PEN13_MODE0&CPC_PIXEL1_MASK_MODE0, // sea green
   CPC_PEN14_MODE0&CPC_PIXEL1_MASK_MODE0, // bright yellow
 
};
 
  
static const unsigned char yellow_pens[4]=
  {
    CPC_PEN1_MODE0&CPC_PIXEL1_MASK_MODE0, // black
    CPC_PEN4_MODE0&CPC_PIXEL1_MASK_MODE0, // red
    CPC_PEN14_MODE0&CPC_PIXEL1_MASK_MODE0, // bright yellow
    CPC_PEN12_MODE0&CPC_PIXEL1_MASK_MODE0, // bright orange
    };
    
    
static const unsigned char white_pens[4]=
  {
    CPC_PEN1_MODE0&CPC_PIXEL1_MASK_MODE0, // black
    CPC_PEN10_MODE0&CPC_PIXEL1_MASK_MODE0, // grey
    CPC_PEN15_MODE0&CPC_PIXEL1_MASK_MODE0, // bright white
    CPC_PEN14_MODE0&CPC_PIXEL1_MASK_MODE0, // bright yellow
    };

/***************************************************************/



/* 
grid arrangement.
numbers indicate array elements.
     ____       ____
    /  0 \____ /  1 \____
    \____/  2  \____/  3 \
    /  4 \____/   5 \____/
    \____/  6 \_____/  7 \
    /  8 \____/   9 \____/
	\____/    \_____/

stored as a rectangular array:
element indicies assuming 1d array:
0,1
2,3
4,5
6,7,
8,9

x,y:

(0,0), (1,0),
(0,1), (1,1),
(0,2), (1,2)
(0,3), (1,3)

6 sides:
	
	 _a__
   f/    \b
   e\____/c
	   d

how to go to next hexagon from current, based on the side you want to go through and x/y position:
odd/even indicate line (y value & 1):
element is calculated as (y*width)+x

     ____       ____
    /  0 \____ /  1 \____
    \____/  2  \____/  3 \
    /  4 \____/   5 \____/
    \____/  6 \_____/  7 \
    /  8 \____/   9 \____/
	\____/    \_____/

odd & even:
a: x=x, y-2 (e.g. 4 to 0, or 6 to 2)
d: x=x, y+2 (e.g. 0 to 4, or 2 to 6)

odd:
b: x+1, y-1 (e.g. 2 to 1)
c: x+1, y+1 (e.g. 2 to 5)
e: x=x, y+1 (e.g. 3 to 5)
f: x=x, y-1 (e.g. 6 to 4)

even:
b: x=x, y-1 (e.g. 4 to 2)
c: x=x, y+1 (e.g. 0 to 2)
e: x=-1, y+1 (e.g. 5 to 6)
f: x=-1, y-1 (e.g. 9 to 6)

7 virus colours choosable

1 colour for infected

all colours can be chosen for grid etc

redraw grid in infected colour
*/

//#define bottom_tile_addr (const unsigned char *)(hexatiles+((VALUE_INFECTED+1)*hex_tile_data_size))

#define VALUE_MASK  0x07
#define VALUE_INFECTED 0x040
#define CONSIDERED_ALL_SIDES  0x080


enum
{
  STRING_TABLE_PLAY = 0,
  STRING_TABLE_YES,
  STRING_TABLE_NO,
  STRING_TABLE_SOUND,
    STRING_TABLE_OFF,
   STRING_TABLE_SFX,
  STRING_TABLE_MUSIC,
 STRING_TABLE_MUSIC_AND_SFX,
  STRING_TABLE_CONTINUE,
  STRING_TABLE_RESTART,
  STRING_TABLE_OPTIONS,
  STRING_TABLE_QUIT,
  STRING_TABLE_EXIT,
  STRING_TABLE_BACK,
  STRING_TABLE_ADJUST,
  STRING_TABLE_TYPE,
  STRING_TABLE_COLOURS,
  STRING_TABLE_HEXAGON,
  STRING_TABLE_RECTANGLE,
  STRING_TABLE_TRIANGLE,
  STRING_TABLE_CODE,
  STRING_TABLE_GFX,
  STRING_TABLE_ARNOLDEMU,
  STRING_TABLE_MACDEATH,
  STRING_TABLE_MCKLAIN,
  STRING_TABLE_NEW,
  STRING_TABLE_RANDOM,
  STRING_TABLE_LEVEL,
  STRING_TABLE_HEXAVIRUS,
  STRING_TABLE_INSTRUCTIONS,
  STRING_TABLE_FAILED,
  STRING_TABLE_SUCCESS,
 STRING_TABLE_TRY_AGAIN,
 STRING_TABLE_PLAY_AGAIN,
 STRING_TABLE_PRESS_SELECT,
};
  

static const unsigned char *StringTable[]=
{
  "Play",
  "Yes",
  "No",
  "Sound",
  "Off",
   "Sfx",
  "Music",
  "Music+Sfx",
  "Continue",
  "Restart",
  "Options",
  "Quit",
  "Exit",
  "Back",
  "Adjust",
  "Tile",
  "Colours",
  "Hexagon",
  "Square",
  "Triangle",
  "Code",
  "Gfx",
  "Arnoldemu",
  "MacDeath",
  "McKlain",
  "New",
  "Random",
  "Level",
  "Hexavirus v0",
  "Instructions",
  "You failed.",
  "Well done.",
  "Try again",
  "Play again",
  "Press select to continue"
};

static int nminmoves = -1;
static const unsigned char *CentraliseText =  "Use controls to adjust the\nscreen position.\n\nPress select to confirm";

#ifdef COMPUTE_MOVES
static const unsigned char *CanBeDone =  "This level can be done in     \nmoves. Good luck!";
#endif

static const unsigned char TileOptions[3] = {STRING_TABLE_HEXAGON, STRING_TABLE_RECTANGLE, STRING_TABLE_TRIANGLE};

static const unsigned char PlayMenu[4] = {STRING_TABLE_CONTINUE, STRING_TABLE_TYPE,STRING_TABLE_COLOURS,STRING_TABLE_BACK};

static const unsigned char OkMenu[1] = {STRING_TABLE_CONTINUE};

static const unsigned char ConfirmMenu[2] = {STRING_TABLE_YES, STRING_TABLE_NO};

static const unsigned char SoundOptions[2] = {STRING_TABLE_OFF, STRING_TABLE_MUSIC};
//static const unsigned char SoundOptions[3] = {STRING_TABLE_OFF, STRING_TABLE_SFX, STRING_TABLE_MUSIC};

static const unsigned char PauseMenu[4] = {STRING_TABLE_CONTINUE, STRING_TABLE_RESTART, STRING_TABLE_OPTIONS, STRING_TABLE_QUIT};

#if CART>0
#ifdef OTHER_TILES
static const unsigned char MainMenu[2] = {STRING_TABLE_PLAY, STRING_TABLE_OPTIONS};
#else
static const unsigned char MainMenu[3] = {STRING_TABLE_PLAY, STRING_TABLE_INSTRUCTIONS,STRING_TABLE_OPTIONS};
#endif
#else
#ifdef OTHER_TILES
static const unsigned char MainMenu[3] = {STRING_TABLE_PLAY, STRING_TABLE_OPTIONS, STRING_TABLE_EXIT};
#else
static const unsigned char MainMenu[4] = {STRING_TABLE_PLAY, STRING_TABLE_INSTRUCTIONS,STRING_TABLE_OPTIONS, STRING_TABLE_EXIT};
#endif
#endif
static const unsigned char TryAgainMenu[2] = {STRING_TABLE_RESTART, STRING_TABLE_QUIT};

static const unsigned char ContinueMenu[2] = {STRING_TABLE_NEW, STRING_TABLE_QUIT};

static const unsigned char OptionsMenu[3] = {STRING_TABLE_SOUND, STRING_TABLE_ADJUST, STRING_TABLE_BACK};


static unsigned char move_stack_x[max_grid_width*max_grid_height];	
static unsigned char move_stack_y[max_grid_width*max_grid_height];	


#ifdef TIMER_DEBUG
static int timer;
static int timer_active;
#endif

typedef struct
{
	unsigned char x;
	unsigned char y;
	unsigned char flags;
	unsigned char pad;
} move;
static unsigned char play_grid[play_grid_width*max_grid_height]; 
static  unsigned char cur_value;
static  unsigned char sel_value;
static unsigned int soundtype;
static unsigned int tiletype;
static unsigned int tilenumsides;
static unsigned char old_sel_value;
static  unsigned int nvirus;
static unsigned int grid_width, grid_height; // width/height
static unsigned int grid_total;		// total number of squares
#ifndef DO_MOVES_REMAINING					
static unsigned int nmovescur;
static unsigned int computeminmoves;
static unsigned int minmoves;
#else
static unsigned int nmovesmin;
static unsigned int nmovesleft;
static unsigned int totalmoves;
#endif
static unsigned char *currentmusic;
static unsigned char state;
static unsigned char backstate;
static unsigned char mainstate;
static unsigned char game_quit;
static volatile unsigned char RandomSeed;
static unsigned char GameSeed;
static volatile unsigned char VsyncMark;
static unsigned int delay;


/*-------------------------------------------------------------------------------*/
void wait_vsync()
{
    cpc_WaitVsyncStart();
    cpc_WaitVsyncEnd();
}


/***************************************************************/
/* do x and y coordinates reference a valid cell? */

int is_valid_cell(int x, int y)
{
	/* was seperate ifs, but this resulted in multiple return 0 being emitted as code */
	/* doing a direct return gives worse code than returning 0 or 1 */
	if (
		(x<0) || 
		(y<0) ||
		(x>=grid_width) ||
		(y>=grid_height)
	)
	{
		return 0;
	}
	
	return 1;
}

/***************************************************************/
/* get value from play grid at the x,y coordinates - x,y must be valid */

unsigned char *get_play_grid_addr(int x, int y)
{
	// calc address in play grid
	int element = (y*play_grid_width)+x;
	// calc address of play grid
	return &play_grid[element];
}

/***************************************************************/

unsigned char get_grid_value(int x,int y)
{
	return get_play_grid_addr(x,y)[0];
}

/***************************************************************/

void set_grid_value(int x,int y, unsigned char v)
{
	get_play_grid_addr(x,y)[0] = v;
}

/***************************************************************/
void infect_grid_cell(int x,int y)
{	
	get_play_grid_addr(x,y)[0]|=VALUE_INFECTED;
}

/***************************************************************/
void uninfect_grid_cell(int x,int y)
{	
	get_play_grid_addr(x,y)[0]&= ~VALUE_INFECTED;
}

/***************************************************************/
void set_all_sides_considered(int x, int y)
{
	get_play_grid_addr(x,y)[0]|= CONSIDERED_ALL_SIDES;
}

/***************************************************************/

void clear_all_sides_considered(int x, int y)
{
	get_play_grid_addr(x,y)[0]&= ~CONSIDERED_ALL_SIDES;
}

/***************************************************************/

void get_neighbour_cell_hex(int x, int y, int *nx, int *ny, int s)
{
	switch (s)
	{
		/* a */
		case 0:
		{
			*nx = x;
			*ny = y-2;
		}
		break;
		
		/* b */
		case 1:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x;
				*ny = y-1;
			}
			else
			{
				/* odd */
				*nx = x+1;
				*ny = y-1;
			}
		}
		break;
		
		/* c */
		case 2:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x;
				*ny = y+1;
			}
			else
			{
				/* odd */
				*nx = x+1;
				*ny = y+1;
			}
		}
		break;

		/* d */
		case 3:
		{
			*nx = x;
			*ny = y+2;
		}
		break;

		/* e */
		case 4:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x-1;
				*ny = y+1;
			}
			else
			{
				/* odd */
				*nx = x;
				*ny = y+1;
			}
		}
		break;

		/* f */
		case 5:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x-1;
				*ny = y-1;
			}
			else
			{
				/* odd */
				*nx = x;
				*ny = y-1;
			}
		}
		break;
		
		default:
		{
			*nx = x;
			*ny = y;
		}
		break;
	}
}

/***************************************************************/

/*
      0
    +-----+
  3 |     | 1
    +-----+
      2
*/

void get_neighbour_cell_rect(int x, int y, int *nx, int *ny, int s)
{
    switch (s)
  {
      case 0:
      {
          *nx = x;
          *ny = y-1;
      }
      break;
      
      case 1:
      {
         *nx = x+1;
         *ny = y;
      }
      break;
      
      case 2:
      {
        *nx = x;
        *ny = y+1;
      }
      break;
      
      case 3:
      {
        *nx = x-1;
        *ny = y;
      }
      break;
      
      default:
        	{
			*nx = x;
			*ny = y;
		}
		break;
  }
}
  
/***************************************************************/

/*


  _ _ _ _ _ _ _ _
/\/\/\/\/\/\/\/\/\
------------------
\/\/\/\/\/\/\/\/\/

0
 --
2\/ 1


2/\0
 --
1

even x, even y -> /\

0: x->x+1, y->y
1: x->x, y->y+1
2: x->x-1, y->y

odd x, even y -> \/

0: x->x, y->y-1
1: x->x+1, y->y
2: x->x-1, y->y

even x, odd y -> \/

0: x->x, y->y-1
1: x->x+1, y->y
2: x->x-1, y->y

odd x, odd y -> /\

0: x->x+1, y->y
1: x->x, y->y+1
2: x->x-1, y->y
*/

void get_neighbour_cell_tri(int x, int y, int *nx, int *ny, int s)
{
  switch (s)
  {
      case 0:
      {
          if (((x^y)&1)!=0)
          {
            /* x and y are not both odd/even */
            *nx = x;
            *ny = y-1;
          }
          else
          {
            *nx = x+1;
            *ny = y;
          }
      }
      break;
      
      case 1:
      {
          if (((x^y)&1)!=0)
          {
            /* x and y are not both odd/even */
            *nx = x+1;
            *ny = y;
          }
          else
          {
            *nx = x;
            *ny = y+1;
          }
      }
      break;
      
      case 2:
      {
          *nx = x-1;
          *ny = y;
      }
      break;
          
      default:
        	{
			*nx = x;
			*ny = y;
		}
		break;
  }
}

/***************************************************************/
/* based on x,y position and side, give new x,y coordinates for neighbour cell; note coords may not be valid */
void get_neighbour_cell(int x, int y, int *nx, int *ny, int s)
{
	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
			return get_neighbour_cell_hex(x,y,nx,ny,s);
#ifdef OTHER_TILES
		case TILE_TYPE_RECTANGLE:
			return get_neighbour_cell_rect(x,y,nx,ny,s);
		case TILE_TYPE_TRIANGLE:
			return get_neighbour_cell_tri(x,y,nx,ny,s);
#endif
		}
}	


/***************************************************************/
/* loop over and remove considered from neighbour cells, this ensures we can reconsider them */
void clear_considered(int x,int y)
{
	int s;
	/* loop over each side */
	for (s=0; s<tilenumsides; s++)
	{
		int x2,y2;

		/* get x,y coord from current position */
		get_neighbour_cell(x,y, &x2, &y2,s);
		
		if (is_valid_cell(x2,y2))
		{
			clear_all_sides_considered(x2,y2);
		}
	}		
	
}

/***************************************************************/
/* remove position from history */

void remove_last_pos()
{
	if (nvirus!=0)
	{
		// go back a virus
		--nvirus;

		// uninfect this cell
		uninfect_grid_cell(move_stack_x[nvirus], move_stack_y[nvirus]);

		// now potentially we need to go back and mark those that
		// had all sides considered to unmark them
		// and they are unlikely to be immediately previous in the list.
		// we could remove it from all neighbours, but that's a bit slow
		clear_considered(move_stack_x[nvirus], move_stack_y[nvirus]);
	}
}


/***************************************************************/
/* add a position to the history, infect the cell, and cause the display to be updated */
void add_pos(int x,int y)
{

	/* store move made */
	move_stack_x[nvirus] = x;
	move_stack_y[nvirus] = y;
	nvirus++;
	
	/* infect the cell */
	infect_grid_cell(x,y);
	
	state = STATE_DRAW_INFECTED_CELL;
}

/***************************************************************/
/* update the infection one cell at a time */

char update_infections()
{
	char infected = 0;

	
	/* go back through the list of cells */
	int i = nvirus-1;

	while (i>=0)
	{
		int x,y;
		unsigned char val;
		
	
		/* get x,y values */
		x = move_stack_x[i];
		y = move_stack_y[i];
		
		/* get value */
		val = get_grid_value(x,y);
		
		/* did we consider all sides already? */
		if ((val & CONSIDERED_ALL_SIDES)==0)
		{
			int s;
			/* side to infect */
			int nsideinfect = -1;
			
			/* number of sides to infect */ 
			int nsidesinfected = 0;
			
			/* loop over each side */
			for (s=0; s<tilenumsides; s++)
			{
				int x2,y2;

				/* get x,y coord from current position */
				get_neighbour_cell(x,y, &x2, &y2,s);
				
				if (is_valid_cell(x2,y2))
				{
					/* current value? */
					unsigned char neighbourval = get_grid_value(x2, y2);
					
					/* update number of sides infected */
					if ((neighbourval & VALUE_INFECTED)!=0)
					{
						++nsidesinfected;
					}
					else
					{	
						/* get value */
						neighbourval &= VALUE_MASK;
						
						/* we did not infect a side yet, and the side has the value we are looking for */
						if ((nsideinfect==-1) && (neighbourval==cur_value))
						{
							nsideinfect = s;
							
							/* add and break out of the loop; we infected a new cell */
							add_pos(x2,y2);

							infected = 1;
              
              			
						}
					}
				}
	
				/* if we just infected all sides, mark it as totally infected so we ignore next time */
				if ((nsidesinfected==(tilenumsides-1)) && infected)
				{
					set_all_sides_considered(x,y);
				}
			
				/* if we just made an infection, quit out now */
				if (infected)
					break;
			}

		/* we infected a new cell! */
		if (infected)	
			break;

		}
		
		/* we didn't infect a cell */
		
		/* go back */	
		--i;
	}
	return infected;
}

/***************************************************************/

void WaitVsyncMark()
{
    while (VsyncMark==0);
  VsyncMark = 0;
}

#ifdef TIMER_DEBUG
void start_timer()
{
	timer_active = 1;
	timer = 0;
}

void stop_timer()
{
	timer_active = 0;
}

int get_timer()
{
	return timer;
}
#endif
/***************************************************************/

void interrupt_handler(void) __critical __interrupt(1) 
{
#ifdef TIMER_DEBUG
	if (timer_active)
	{
		++timer;
	}
#endif
	if (cpc_InVsync())
	{
    ArkosPlayer2_Play();
    VsyncMark = 1;

  /* keys can be pressed/released at any time during a frame, we scan the keyboard to get them at the point we scanned */
  
  /* scan them and update them here when we want to know their current state, doing it in an charerrupt means that
  the values we see can be out of step */
		//cpc_BackupKeys();
		//cpc_ScanKeyboard();

		
		/* NOTE: 
		1. This is effectively a random number based on time.
		2. We set the random seed when the game is started.
		3. We only ever start the game around vsync time.
		4. So there is no point incrementing the random seed at any other time
		because then we will end up with a seed which is not good.
		e.g. if we incremented it every interrupt we would end up with a seed which
		is a multiple of 6, and we would always get an even random number seed, the result,
		is we could not get random numbers in range 0-1 */
		
		
		RandomSeed++;
	}
}


/***************************************************************/

void stop_arkos_music()
{
	cpc_DisableMaskableInterrupts();

	/* stop the sound */
	ArkosPlayer2_Stop();
  
  cpc_EnableMaskableInterrupts();
}

/***************************************************************/

void play_sound(int flags, const unsigned char *current_sound)
{
	/* if no sound, don't play it */
	if (soundtype==SOUND_TYPE_NONE)
		return;
		
  /* always play? */
  if ((flags & SOUND_FLAG_ALWAYS)==0)
  {    
    /* no */
    
	/* if sound effect and not sound effect mode, don't play it */
	if ((soundtype!=SOUND_TYPE_SFX) && ((flags & SOUND_FLAG_SFX)!=0))
		return;
		
    /* SOUND_TYPE_MUSIC and music */
      /* music and not forced then remember it */
    if ((flags & SOUND_FLAG_SFX)==0)
    {
    	currentmusic = current_sound;
    }
  }
	
  cpc_DisableMaskableInterrupts();
  
  /* stop the sound */
	ArkosPlayer2_Stop();

  ArkosPlayer2_Init(0,current_sound); 

  
  /* set the player active */
  ArkosPlayer2_SetActive(1);

  
	/* enable it */
	cpc_EnableMaskableInterrupts();
	
  // TODO LOOPED/FINISHED
	if (flags & SOUND_FLAG_WAIT_FOR_END)
	{
	ArkosPlayer2_ResetLooped();
	while (!ArkosPlayer2_HasLooped())
	{
	wait_vsync();
	}
    }
}

/***************************************************************/

#define FRAC_DIV 16
#define FRAC_BITS 4
#define X_INC 2
#define X_INC_SHIFT 1
#define Y_INC 2
#define Y_INC_SHIFT 1

/* this will keep track of how many of each colour is available */
static __at (0x2000)     int num_useable[MAX_COLOURS];
 
void grid_init()
{	
	//int i;
	unsigned char *pGrid = play_grid;
  
	/* ensure we don't get a random seed of 0 */
	{
		/* initialise random seed */
		int Seed = GameSeed;
		if (Seed==0)
		{
			/* some default seed */
			Seed=0x0aa;
		}
			
		cpc_SetRandSeed(Seed);
	}

	
	// value noise in a 2x2 grid
	
	// fill
	{
		int x,y;
		
		for (y=0; y<grid_height; y++)
		{
			for (x=0; x<grid_width; x++)
			{
				set_grid_value(x,y,0x0ff);
			}
		}
	}
	

	// setup grid - ideally do it as a hexagon, but we treat it as a rectangular grid
	{	
		int y = 0;
		while (y<grid_height)
		{
			int x = 0;
			while (x<grid_width)
			{
				set_grid_value(x,y,cpc_RandomInRange(MAX_COLOURS));
					
				if (x==(grid_width-1))
					break;
				
				x  = x + X_INC;
				
				if (x>=grid_width)
				{
					x = grid_width-1;
				}
			}

			if (y==(grid_height-1))
				break;
			y = y+Y_INC;		// needs to be twice the height for hexagon grids
			if (y>=grid_height)
			{
				y = grid_height-1;
			}
		}
	}

	// interpolate
		{
		int x,y;
		
		for (y=0; y<grid_height; y++)
		{
			int yd = y&(Y_INC-1);
			int py = y-yd;
			int ny = py+Y_INC;
			signed int yf = yd<<(FRAC_BITS-Y_INC_SHIFT);

			if (ny>=grid_height)
			{
				ny = grid_height-1;
			}
			//printf("py: %d ny %d yf: %f\n",py,ny,(float)yf/(float)FRAC_DIV);
			
			for (x=0; x<grid_width; x++)
			{
				int xd = x&(X_INC-1);
				int px = x-xd;
				int nx = px+X_INC;
				signed int xf = xd<<(FRAC_BITS-X_INC_SHIFT);
		
				if (nx>=grid_width)
				{
					nx = grid_width-1;
				}

				//printf("pX: %d nX %d Xf: %f\n",px,nx, (float)xf/(float)FRAC_DIV);
			
				unsigned char val = get_grid_value(x,y);
				if (val==0x0ff)
				{
					signed char corners[4];
					signed char xdiff1, xdiff2;
					signed int xvdiff;
					signed int xv1,xv2;
					signed int v;
							
					corners[0] = get_grid_value(px,py);
					corners[1] = get_grid_value(nx,py);
					corners[2] = get_grid_value(px,ny);
					corners[3] = get_grid_value(nx,ny);
					
					//printf("corners: %d %d %d %d\n",corners[0], corners[1], corners[2], corners[3]);
					
					xdiff1 = corners[1]-corners[0];
					xdiff2 = corners[3]-corners[2];
					
					xv1 = ((signed int)xdiff1*xf)+((signed int)corners[0]<<FRAC_BITS);
					xv2 = ((signed int)xdiff2*xf)+((signed int)corners[2]<<FRAC_BITS);

					xvdiff = xv2-xv1;

					v =(((xvdiff*yf)>>FRAC_BITS)+xv1)>>FRAC_BITS;
					
					set_grid_value(x,y,v&0x0ff);
				}
			}
		}
	}
	
#if 0
	
  {
	unsigned char *pGridCur = pGrid;
	int y,x;

    /* perhaps use lattice noise or perlin noise.
    generate numbers, interpolate and lock to floor integer    
*/
	  /* number of elements in grid */
    /* number of each colour when shared between them all */
    int num_each = grid_total/num_colours;
    /* this is the number of chooseable colours; when some reach 0 count, we can't choose them anymore */
    int num_chooseable_colours = num_colours;
    int c;
    /* initialise number of each colours we can choose */
    for (c = 0; c<num_colours; c++)
    {
        num_useable[c] = num_each;
    }
   
    for (y = grid_height; y!=0; y--) 
    {	
		unsigned char *pGridStore = pGridCur;
	
		for (x = grid_width; x!=0; x--)
		{
			  int colour=0;
			  /* if we exhausted each colour */
			  if (num_chooseable_colours==0)
			  {
				/* choose a random one to fill in */
				colour = cpc_RandomInRange(num_colours);
			  }
			  else
			  {
				/* choose from one of the available colours */
				int colour_index = cpc_RandomInRange(num_chooseable_colours);
				for (c=0; c<num_colours; c++)
				{
					/* find which it is */
					int num_useable_this_colour = num_useable[c];
					if (num_useable_this_colour!=0)
					{
						/* is this the one we wanted? */
						if (colour_index==0)
						{
						  /* found it */
						  colour = c;
						  
						  num_useable_this_colour--;
						  /* we used up all it's supply? */
						  if (num_useable_this_colour==0)
						  {
							/* one less colour to choose from */
							  num_chooseable_colours--;
						  }
						  /* update how many are remaining */
						  num_useable[c] = num_useable_this_colour;
						  break;
					  }
					  else
					  {
						  /* this one is useable */
						  colour_index--;
					  }
					}
				}
			  }
					
			  *pGridCur = colour;
			  ++pGridCur;
		}
		pGridCur = pGridStore;
		pGridCur += play_grid_width;
	}
  }
#endif
#if 0	
  // totally random is not good.
	for (i = 0; i < grid_total; i++) 
	{	
		/* random number between 0 and 6 */
		*pGrid = cpc_RandomInRange(7);
		++pGrid;
	}
  #endif
}

/***************************************************************/

void draw_grid_tile(int x,int y, int gx, int gy)
{
	/* calc scr addr */
	unsigned char *scraddr = cpc_GetScrAddr(x,y);
	/* read tile from grid */
	unsigned char grid_value = get_grid_value(gx,gy);

	if ((grid_value & VALUE_INFECTED)!=0)
	{
		grid_value = MAX_COLOURS;
	}
	else
	{
		grid_value &= VALUE_MASK;
	}
	
	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
		{
			/* get tile graphics addr */
			const unsigned char *tileaddr = hexatiles+((unsigned int)grid_value*hex_tile_data_size);
			/* draw the tile */
			cpc_SprMask0(scraddr, tileaddr, hex_tile_width_bytes, hex_tile_height);
		}
		break;
#ifdef OTHER_TILES		
		case TILE_TYPE_RECTANGLE:
		{
			/* get tile graphics addr */
			const unsigned char *tileaddr = recttiles+((unsigned int)grid_value*rect_tile_data_size);
			/* draw the tile */
			cpc_SprMask0(scraddr, tileaddr, rect_tile_width_bytes, rect_tile_height);
		}
		break;
		
		case TILE_TYPE_TRIANGLE:
			{
				// when x&1 ^ y&1 the same, then we can use point up
				// else we use point down
				const unsigned char *tileaddr;
				
				// x = 0, y=0 -> up     -> 0^0 = 0
				// x = 1, y=0 -> down -> 1^0 = 1
				// x = 0, y=1 -> down -> 0^1 = 1
				// x = 1, y=1 -> up     -> 1^1 = 0
				
				if (((gx^gy)&1)==0)
				{
					grid_value += TRI_POINT_UP_INDEX;
				}
		//		grid_value = 5;
				/* get tile graphics addr */
				tileaddr = tritiles+((unsigned int)grid_value*tri_tile_data_size);
				/* draw the tile */
				cpc_SprMask0(scraddr, tileaddr, tri_tile_width_bytes, tri_tile_height);
			
			}
			break;
#endif
	}
}


/***************************************************************/

void redraw_grid_element(int gx,int gy)
{
	int x=0,y=0;

	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
		{
			x = xorg + (gx*(hex_third_tile_width+hex_tile_width_bytes));
			y = yorg;
		
			if ((gy&1)!=0)
			{
				x += hex_two_third_tile_width;
			}
			
			y+= (gy*hex_half_tile_height);
		}
		break;
#ifdef OTHER_TILES		
		case TILE_TYPE_RECTANGLE:
		{
			x = xorg + (gx*rect_tile_width_bytes);
			y = yorg + (gy*rect_tile_height);
		}
		break;
		
		case TILE_TYPE_TRIANGLE:
		{
			x = xorg + (gx*tri_half_tile_width);
			y = yorg + (gy*tri_tile_height);
		}
		break;
#endif
	}

	draw_grid_tile(x,y,gx,gy);
}


/***************************************************************/

void update_xy(int*x,int *y, int *inc, int dir)
{
    int ix = *x;
  int iy = *y;
  int iinc = *inc;
  
   if (iinc<0)
   {
     if (ix==0)
     {
       iy+=dir;
       *y = iy;
       iinc = -iinc;
       *inc = iinc;
     }
     else
     {
        ix--;
        *x = ix;
     }
   }
   else
   {
     if (ix==(grid_width-1))
     {
       iy+=dir;
       *y = iy;
       iinc = -iinc;
       *inc = iinc;
     }
     else
     {
       ix++;
       *x=ix;
     }
   }
  
}
/***************************************************************/

/* draw in a snake like way on the screen */
void draw_grid()
{
  int x1,y1,x2,y2;
  int i;
  int inc1, inc2;
  int tiles ;
  inc1 = 1;
  inc2 = -1;
  x1 = 0;
  y1 = 0;
  x2 = grid_width-1;
  y2 = grid_height-1;
  
  tiles = (grid_total+1)>>1;
   for (i=0; i<tiles; i++)
  {
    wait_vsync();
      redraw_grid_element(x1,y1);
      redraw_grid_element(x2,y2);
      update_xy(&x1,&y1,&inc1, 1);
      update_xy(&x2,&y2, &inc2,-1);
  }

/***************************************************************/

  
 #if 0 
  
  
	int x,y;
	int w,h;
	
	y = yorg;
	
	for (h = 0; h<grid_height; h++)
	{
		x = xorg;
		if ((h&1)!=0)
		{
			x +=two_third_tile_width;
		}
		
		for (w = 0; w<grid_width; w++)
		{
			draw_grid_tile(x,y,w,h);
			/* update for next */
			x+=(third_tile_width+tile_width_bytes);
		}
		y+=half_tile_height;
	}
	
	/* bottom line */
	x = xorg;	//+two_third_tile_width;
	
	for (w = 0; w<twice_grid_width; w++)
	{
		int sy = y;
		unsigned char *scraddr;
		if ((w&1)!=0)
		{
			sy += half_tile_height;
		}

		/* calc scr addr */
		scraddr = cpc_GetScrAddr(x,sy);
	
		/* draw the tile */
		cpc_SprMask0(scraddr, bottom_tile_addr, tile_width_bytes, 1);

		x+=(two_third_tile_width);
	}
#endif
}

/*-------------------------------------------------------------------------------*/


unsigned char *legend_addr[8]={
 SCR_ADDR_FROM_COORD(SELECT_X,28+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,52+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,76+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,100+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,124+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,148+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,172+legend_y),
 SCR_ADDR_FROM_COORD(SELECT_X,196+legend_y)
};
  
/*-------------------------------------------------------------------------------*/

void draw_legend_item(int npos)
{
  unsigned char *scraddr = (unsigned char *)legend_addr[npos];
    if (sel_value==npos)
    {
      cpc_SprMask0(scraddr, select_sprite, select_width_bytes, select_height);
    }
    else
    {
      cpc_SprMask0(scraddr, unselect_sprite, select_width_bytes, select_height);
    }      
 }

/*-------------------------------------------------------------------------------*/

void draw_legend()
{
  unsigned char *scraddr = SCR_ADDR_FROM_COORD(legend_x,legend_y);
  cpc_SprReplaceLarge(scraddr, legend, legend_width_bytes, legend_height);
}


/***************************************************************/

/* colours for the pens for the choices */
const unsigned char Colours[]={
  HW_INK_RED, HW_INK_BRIGHT_RED,
  HW_INK_BRIGHT_RED, HW_INK_ORANGE,
  HW_INK_GREEN,HW_INK_BRIGHT_YELLOW,
  HW_INK_GREEN,HW_INK_SEA_GREEN,
  HW_INK_BLUE, HW_INK_MAUVE,
  HW_INK_BLUE,HW_INK_BRIGHT_BLUE,
  HW_INK_BRIGHT_BLUE,HW_INK_SKY_BLUE
};

#define PEN_MOVE_DARK 5
#define PEN_MOVE_LIGHT 7 

/***************************************************************/
/* update the choice colour */
void set_colour_choice(int choice)
{
  int colour_index = choice<<1;
  cur_value = choice;
  /* change colour */
  cpc_SetColourHW(PEN_MOVE_DARK, Colours[colour_index]);
  colour_index++;
  cpc_SetColourHW(PEN_MOVE_LIGHT,Colours[colour_index]);
  
    
}


/***************************************************************/
/* start the game, we infect the bottom-left cell, this may spark infections based on it's value and it's neighbours */
#ifdef COMPUTE_MOVES
int find_min_moves();
#endif

void new_game()
{
	int x,y;
	
	/* number of moves so far */
	nvirus = 0;
	
#ifndef DO_MOVES_REMAINING	
	nmovescur = 0;
#else
	nmovesleft = totalmoves;
#endif
	
	/* initialise play grid */
	grid_init();

	// setup initial move
	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
		{
      if ((grid_height & 1)==0)
      {
        x = 0;
        y = grid_height-2;
      }
      else
      {
         x = 0;
         y = grid_height-1;
      }

		}
		break;
#ifdef OTHER_TILES		
		case TILE_TYPE_RECTANGLE:
		{
        x = 0;
       y = grid_height-1;
		}
		break;
		
		case TILE_TYPE_TRIANGLE:
		{
			x = 0;
			y = grid_height-1;
		}
		break;
#endif
	}
	
	/* this is the current value */
  set_colour_choice(get_grid_value(x,y));
  
  /* selected values */
  old_sel_value = cur_value;
  sel_value = cur_value;
	
	/* now infect and start the process */
	add_pos(x,y);
	
#if COMPUTE_MOVES

	/* do not compute on restart! */
	/* find minimum number of moves */
	if (computeminmoves)
	{
		nmovesmin = find_min_moves();
	}
#endif
	
}

unsigned char PreviousAnalogue;
unsigned char CurrentAnalogue;
unsigned char AnalogueChanged;

int TestAnalogueLeftReleased()
{
    if (plus)
    {
	    if (
		    ((AnalogueChanged&(1<<0))!=0) && 
			((CurrentAnalogue&(1<<0))==0)
		)
	    {
		    return 1;
	    }
    }
    return 0;
  }

  
int TestAnalogueRightReleased()
{
    if (plus)
    {
       if (
		    ((AnalogueChanged&(1<<1))!=0) && 
			((CurrentAnalogue&(1<<1))==0)
		)
	    {
		    return 1;
	    }
    }
    return 0;
  }

   
int TestAnalogueUpReleased()
{
    if (plus)
    {
      if (
		    ((AnalogueChanged&(1<<2))!=0) && 
			((CurrentAnalogue&(1<<2))==0)
		)
	    {
		    return 1;
	    }
    }
    return 0;
  }

  
  
int TestAnalogueDownReleased()
{
    if (plus)
    {
         if (
		    ((AnalogueChanged&(1<<3))!=0) && 
			((CurrentAnalogue&(1<<3))==0)
		)
	    {
		    return 1;
	    }
    }
    return 0;
  }

  
/***************************************************************/
int LeftPressed()
{
  	if (
		/* joy left */
		cpc_TestKeyReleased(CPC_KEY_JOY0_LEFT) ||
		cpc_TestKeyReleased(CPC_KEY_JOY1_LEFT) ||
		/* cursor left */
		cpc_TestKeyReleased(CPC_KEY_CURSOR_LEFT) ||
    /* analogue joystick 0 left */
    TestAnalogueLeftReleased()
    )
  {
      return 1;
  }
  return 0;
}

/***************************************************************/
int RightPressed()
{
  	if (
		/* joy right */
		cpc_TestKeyReleased(CPC_KEY_JOY0_RIGHT) ||
		cpc_TestKeyReleased(CPC_KEY_JOY1_RIGHT) ||
		/* cursor right */
		cpc_TestKeyReleased(CPC_KEY_CURSOR_RIGHT) ||
    /* analogue joystick 0 right */
    TestAnalogueRightReleased())
  {
      return 1;
  }
  return 0;
}

/***************************************************************/
int UpPressed()
{
  	if (
		/* joy up */
		cpc_TestKeyReleased(CPC_KEY_JOY0_UP) ||
		cpc_TestKeyReleased(CPC_KEY_JOY1_UP) ||
		/* cursor up */
		cpc_TestKeyReleased(CPC_KEY_CURSOR_UP) ||
    /* analogue joystick 0 up */
    TestAnalogueUpReleased()
    )
  {
      return 1;
  }
  return 0;
}
/***************************************************************/
int DownPressed()
{
  	if (
		/* joy down */
		cpc_TestKeyReleased(CPC_KEY_JOY0_DOWN) ||
		cpc_TestKeyReleased(CPC_KEY_JOY1_DOWN) ||
		/* cursor down */
		cpc_TestKeyReleased(CPC_KEY_CURSOR_DOWN) ||
    /* analogue joystick 0 down */
      TestAnalogueDownReleased()
    )
  {
      return 1;
  }
  return 0;
}
/***************************************************************/
int SelectPressed()
{
  if (
  		/* joy fire  */
		cpc_TestKeyReleased(CPC_KEY_JOY0_FIRE1) ||
		cpc_TestKeyReleased(CPC_KEY_JOY0_FIRE2) ||
		cpc_TestKeyReleased(CPC_KEY_JOY1_FIRE1) ||
		cpc_TestKeyReleased(CPC_KEY_JOY1_FIRE2) ||
		/* space */
		cpc_TestKeyReleased(CPC_KEY_SPACE) ||
		cpc_TestKeyReleased(CPC_KEY_RETURN)
  )
  {
    return 1;
  }
  return 0;
}
/***************************************************************/

void update_input()
{
	cpc_BackupKeys();
	cpc_ScanKeyboard();
	
    if (plus)
    {
	    PreviousAnalogue = CurrentAnalogue;
	    
  	    plus_RegisterPageEnable();
	   CurrentAnalogue = plus_GetAnalogueJoystickAsDigital(0);
		plus_RegisterPageDisable();
	    AnalogueChanged = CurrentAnalogue^PreviousAnalogue;
    }

	
}

void handle_input()
{
	int new_value = -1;

		wait_vsync();
update_input();
	
  if (cpc_TestKeyReleased(CPC_KEY_ESC))
  {
      state = SUB_STATE_QUIT_MENU;
    return;
  }
	/* handle left/right and select first */
	if (LeftPressed() || UpPressed() )
		{
			if (sel_value!=0)
			{
        old_sel_value = sel_value;
				--sel_value;
				state = STATE_CHANGE_CHOICE;
			}
			return;
		}	
	else
	if (RightPressed() || DownPressed() )
		{
			if (sel_value!=(MAX_SEL-1))
			{
        old_sel_value = sel_value;
				++sel_value;
				state = STATE_CHANGE_CHOICE;
			}
			return;
		}
	else
	if (SelectPressed())
	{
      if (sel_value==(MAX_SEL-1))
      {
        /* options */
          state = SUB_STATE_PAUSE_MENU;
      }
      else
	  {
		  if (sel_value<num_colours)
		  {
		  /* choice within number of colours range */
			if (sel_value!=cur_value)
			{
				state = STATE_SELECT_CHOICE;
			}
		
			return;
			}
			else
			{
				// choice outside number of colours range
			
			}
		}
	}

}

/***************************************************************/
/* crtc values for overscan */
//const unsigned char CRTCRegisters[]={0x03f, 48, 48, 0x086, 0x026, 0, 34, 35,0,7,0,0,0x0c,196};
// 0x0188

#define INITIAL_CRTC_R2 48
#define INITIAL_CRTC_R7 35

#define MAX_CRTC_R2 53
#define MIN_CRTC_R2 38
#define MAX_CRTC_R7 38
#define MIN_CRTC_R7 30

unsigned char CrtcR2 = INITIAL_CRTC_R2;
unsigned char CrtcR7 = INITIAL_CRTC_R7;

// R3 which works well with non-black borders on televisions
#define GOOD_R3 0x08e

const unsigned char CRTCRegisters[]={0x03f, CRTC_R1, INITIAL_CRTC_R2, GOOD_R3, 0x026, 0, CRTC_R6, INITIAL_CRTC_R7,0,CRTC_R9-1,0,0,0x0c,196};

char num_str[4];

void setup_moves_string(int nmoves)
{
	int nmoves_hundreds, nmoves_tens, nmoves_units;
	int nmovesthis = nmoves;
	nmoves_hundreds = nmovesthis/100;
	nmovesthis = nmovesthis-(nmoves_hundreds*100);
	nmoves_tens = nmovesthis/10;
	nmovesthis = nmovesthis-(nmoves_tens*10);
	nmoves_units = nmovesthis;
	num_str[0] = nmoves_hundreds+'0';
	num_str[1] = nmoves_tens+'0';
	num_str[2] = nmoves_units+'0';
	num_str[3] = '\0';
}

/***************************************************************/
/* draw number of moves remaining */
void draw_moves()
{
#ifndef DO_MOVES_REMAINING					
	int nmoves_tens = nmovescur/10;
	int nmoves_units = nmovescur-(nmoves_tens*10);
#else
	int nmoves_tens = nmovesleft/10;
	int nmoves_units = nmovesleft-(nmoves_tens*10);
#endif	
	unsigned char *scr_addr_tens = SCR_ADDR_FROM_COORD(number_x,number_y);
		
	const unsigned char *gfx_tens = numbers+(nmoves_tens*number_data_size);
	const unsigned char *gfx_units = numbers+(nmoves_units*number_data_size);
	cpc_SprReplace(scr_addr_tens, gfx_tens, number_width_bytes, number_height);
	
	cpc_SprReplace(scr_addr_tens+(number_width_bytes), gfx_units, number_width_bytes, number_height);
}

/*-------------------------------------------------------------------------------*/
void set_silence()
{
      ArkosPlayer2_SetActive(0);
      ArkosPlayer2_Stop();
}

#if 0
void draw_min_moves()
{
	int nmoves_tens = nmovesmin/10;
	int nmoves_units = nmovesmin-(nmoves_tens*10);
		unsigned char *scr_addr_tens = SCR_ADDR_FROM_COORD(min_number_x,min_number_y);

		const unsigned char *gfx_tens = numbers+(nmoves_tens*number_data_size);
	const unsigned char *gfx_units = numbers+(nmoves_units*number_data_size);
	cpc_SprReplace(scr_addr_tens, gfx_tens, number_width_bytes, number_height);
	
	cpc_SprReplace(scr_addr_tens+(number_width_bytes), gfx_units, number_width_bytes, number_height);
}
#endif

/*-------------------------------------------------------------------------------*/
void set_sound_type()
{
	/* if silence, we stop sound */
	switch (soundtype)
	{
		case SOUND_TYPE_SFX:
		case SOUND_TYPE_NONE:
		{
			set_silence();
      // play silence
		}
		break;
		
		case SOUND_TYPE_MUSIC:
		{
			/* restart music */
			play_sound(0, currentmusic);
		}
		break;
    
    case SOUND_TYPE_MIXED:
    {
			/* restart music */
			play_sound(0, currentmusic);
    }
    break;
    
	}			
}

/*-------------------------------------------------------------------------------*/

void cycle_sound()
{
	soundtype++;
	if (soundtype==SOUND_TYPE_MAX)
  {
      soundtype = SOUND_TYPE_MIN;
  }
  set_sound_type();
}

/*-------------------------------------------------------------------------------*/

void cycle_colours_type()
{
	num_colours++;
	if (num_colours>MAX_COLOURS)
	{
		num_colours = MIN_COLOURS;
	}
}
	
/*-------------------------------------------------------------------------------*/
#ifdef OTHER_TILES
void cycle_tile_type()
{
	tiletype++;
	if (tiletype==TILE_TYPE_MAX)
		tiletype= TILE_TYPE_MIN;
}
#endif
/*-------------------------------------------------------------------------------*/


void centralise_screen()
{

  int doing_adjust = 1;
/* get tile graphics addr */
const unsigned char *tileaddr = hexatiles+((unsigned int)0*hex_tile_data_size);

		clearLogo();

// clear screen
cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));

// rectangle behind text	
  cpc_ClearRectangle(SCR_ADDR_FROM_COORD(CENTRALISE_RECT_X,CENTRALISE_RECT_Y),CENTRALISE_RECT_WIDTH_BYTES,CENTRALISE_RECT_HEIGHT,CLR_COLOUR);

	cpc_SetLetterPens(yellow_pens);

// adjustment text
  cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CENTRALISE_RECT_CX+1),SCR_CHAR_TO_LINEY0(CENTRALISE_RECT_CY+1)), CentraliseText);

	/* draw tiles in each corner */
	cpc_SprMask0(SCR_ADDR_FROM_COORD(0,0), tileaddr, hex_tile_width_bytes, hex_tile_height);
	cpc_SprMask0(SCR_ADDR_FROM_COORD(SCR_WIDTH_BYTES-hex_tile_width_bytes,0), tileaddr, hex_tile_width_bytes, hex_tile_height);
	cpc_SprMask0(SCR_ADDR_FROM_COORD(0,SCR_HEIGHT_PIXELS-hex_tile_height), tileaddr, hex_tile_width_bytes, hex_tile_height);
	cpc_SprMask0(SCR_ADDR_FROM_COORD(SCR_WIDTH_BYTES-hex_tile_width_bytes,SCR_HEIGHT_PIXELS-hex_tile_height), tileaddr, hex_tile_width_bytes, hex_tile_height);

	
  while (doing_adjust)
  {
		wait_vsync();
	  update_input();

    if (LeftPressed())
    {
      /* move left */
      if (CrtcR2!=MAX_CRTC_R2)
      {
        CrtcR2++;
      }
    }

    if (RightPressed())
    {
      /* move right */
      if (CrtcR2!=MIN_CRTC_R2)
      {
        CrtcR2--;
      }
    }
    
    if (UpPressed())
    {
      if (CrtcR7!=MAX_CRTC_R7)
      {
        CrtcR7++;
      }
    }
    
  if (DownPressed())
  {  
    if (CrtcR7!=MIN_CRTC_R7)
    {
      CrtcR7--;
    }
  }

/* write register 2 */
  cpc_CRTCWriteRegister(2, CrtcR2);
/* write register 7 */
  cpc_CRTCWriteRegister(7, CrtcR7);

  
  if (SelectPressed())
  {
      doing_adjust = 0;
  }
}
 state =  SUB_STATE_OPTIONS_MENU ;
}
 

/*-------------------------------------------------------------------------------*/

void plot_menu_indicator(unsigned short x, unsigned short y, unsigned short index, const unsigned char *ch)
{
	unsigned char *Addr = cpc_GetScrAddr(SCR_CHAR_TO_BYTEX0(x+1), SCR_CHAR_TO_LINEY0(index+y+1));
	cpc_SetLetterPens(white_pens);
	cpc_DisplayString(Addr, ch);
}

/***************************************************************/

void update_indicator(int x, int y, int itemold, int itemnew)
{
  plot_menu_indicator(x,y,itemold," ");
  plot_menu_indicator(x,y,itemnew,"{");
  play_sound(SOUND_FLAG_WAIT_FOR_END|SOUND_FLAG_SFX, move_music);
}


unsigned short continuemenu(unsigned short itemcount, unsigned short x,unsigned short y, unsigned short itemsel)
{
	unsigned short selected = 0;
	unsigned short item = itemsel;
	
	plot_menu_indicator(x,y,item,"{");
	while (selected==0)
	{
		wait_vsync();
		update_input();	
	
		if (SelectPressed())
		{	
      play_sound(SOUND_FLAG_WAIT_FOR_END|SOUND_FLAG_SFX, selected_music);
				
			selected = 1;
		}
		else
		if (LeftPressed() || UpPressed())
		{
			if (item!=0)
			{
        int olditem = item;
				item--;
        update_indicator(x,y,olditem, item);
			}
		}
		/* down */
		else if (RightPressed() || DownPressed())
		{
			if (item!=(itemcount-1))
			{
        int olditem = item;
				item++;
        update_indicator(x,y,olditem, item);
			}
		}		
	
	}
	return item;
}

/***************************************************************/

/* draw menu inks */
void initmenu(unsigned short itemcount, const unsigned char *items, unsigned short x, unsigned short y)
{
	unsigned short i;
	unsigned short xbyte = SCR_CHAR_TO_BYTEX0((x+2));
	unsigned short yline = SCR_CHAR_TO_LINEY0(y+1);

	cpc_SetLetterPens(blue_pens);

	for (i=0; i<itemcount; i++)
	{
		unsigned char *Addr = cpc_GetScrAddr(xbyte, yline);
		const unsigned char ItemId = items[i];
		const unsigned char *pString = StringTable[ItemId];
		cpc_DisplayString(Addr, pString);
		yline+=LETTER_HEIGHT;
	}
}
/***************************************************************/

int confirm_menu(int x,int y)
{
	// no clear needed here
	initmenu(ARRAY_COUNT(ConfirmMenu),ConfirmMenu,x,y);

	return continuemenu(ARRAY_COUNT(ConfirmMenu),x,y,1);
}

#if 0
/***************************************************************/

int ok_menu()
{
	initmenu(ARRAY_COUNT(OkMenu),OkMenu,0,0);

	return continuemenu(ARRAY_COUNT(OkMenu),0,0,0);
}
#endif
/***************************************************************/
void display_sound_options(unsigned char *Addr)
{
	unsigned char SoundOptionId = SoundOptions[soundtype];
	cpc_SetLetterPens(white_pens);
	cpc_ClearRectangle(Addr, (8*2), 8, CLR_COLOUR);
	cpc_DisplayString(Addr, StringTable[SoundOptionId]);
}
  
/***************************************************************/
void display_tile_options(unsigned char *Addr)
{
	unsigned char TileOptionId  = TileOptions[tiletype];
	cpc_SetLetterPens(white_pens);
	cpc_ClearRectangle(Addr, (8*2), 8, CLR_COLOUR);
	cpc_DisplayString(Addr, StringTable[TileOptionId]);
}
/***************************************************************/

void display_colour_options(unsigned char *Addr)
{
	char sNumber[2];
	sNumber[0] = num_colours+'0';
	sNumber[1] = '\0';

	cpc_SetLetterPens(white_pens);
	cpc_ClearRectangle(Addr, (8*2), 8, CLR_COLOUR);
	cpc_DisplayString(Addr, sNumber);
}

/***************************************************************/
void sub_state_options_menu(int x, int y, const unsigned char *scraddr, int widthbytes, int heightlines)
{
	int item = 0;
	int donemenu = 0;
	
	cpc_ClearRectangle(scraddr, widthbytes, heightlines,CLR_COLOUR);
	initmenu(ARRAY_COUNT(OptionsMenu),OptionsMenu,x,y);
	display_sound_options(cpc_GetScrAddr(SCR_CHAR_TO_BYTEX0(x+12), SCR_CHAR_TO_LINEY0(y+1)));
  
	donemenu = 0;
	while (donemenu==0)
	{
		item = continuemenu(ARRAY_COUNT(OptionsMenu),x,y,item);
	
		switch (item)
		{
			/* sound */
			case 0:
			{
				cycle_sound();
				display_sound_options(cpc_GetScrAddr(SCR_CHAR_TO_BYTEX0(x+12), SCR_CHAR_TO_LINEY0(y+1)));
			}
			break;
      
		/* centralise */
		  case 1:
		  {
			state = SUB_STATE_CENTRALISE_SCREEN;
	
			donemenu = 1;
			}
			break;
      
        /* back */
			default:
			  {
				state = backstate;
				donemenu = 1;
			  }
			  break;
		}
	}

}

static const char *Instructions = \
"Grow your virus to cover all\n" \
"the cells of the play area.\n\n" \
"See if you can equal or beat\n" \
"the number of suggested moves.\n\n" \
"Choose a colour and every cell\n" \
"that the virus touches with\n" \
"that colour will be infected.\n\n" \
"The bottom left cell is infected\n" \
"at the beginning of the game.\n\n" \
"Press select to go back to the\n" \
"main menu";

#if COMPUTE_MOVES
static const char *PleaseWait = "Please wait...";


// find best move sequence
//
// if move results in no change, ignore and don't add.
// 
// otherwise try it and see if it less moves to complete, if not try another value
//
// each time go back a move and try another, if this results in better moves, keep it.
// go back only when we have tried all moves.
#if 0
void find_min_moves()
{
	move_count = 0;
	min_move_count = -1;
	move_count = -1;
	
	// we may have other moves that complete 
	
	// this is the initial move.
	int move_wanted = 0;
	
	// keep going..
	do
	{
		if (move_count!=0)
		{
			// go back a move..
			--move_count;
			
			// get the previous move we tried..
			move_wanted = move_sequence[move_count];
		}
		for (; move_wanted<num_colours; move_wanted++)
		{
			int total_infected = 0;
			char infected;
			
			// set the move
			cur_value = move_wanted;

			// update the infection until it's done
			// count the number of moves as it does it.
			do
			{
				infected = update_infections();
				if (infected!=0)
				{
					total_infected++;
				}
			}
			while (infected!=0);

			// it has finished the infection
			if (total_infected!=0) 
			{
				// did we complete the grid?
				if (nvirus==grid_total)
				{
					// we did!
					++move_count;

					// this is the number of moves
					if (move_count<min_move_count)
					{
						// this is much better, but is it the best?
						min_move_count = move_count;
						
						// we should back track...
					}
				}
				else
				{
					// out of moves buffer, it's not going to be good either
					if (
					// if this means move moves than minimum so far
					(move_count>min_move_count) ||
					// or this means we are out of buffer space
					(move_count>=MOVE_SEQUENCE_MAX)
					{	
						// back track!
					}
				
					// this move is good, store it.
					move_sequence[move_count] = i;
					++move_count;
				}
			}
			else
			{
				// this move didn't result in any being eliminated
			}
				
				
			
			// go back a move?
		}
	}	
	while ((move_count!=1) && (move_wanted!=num_colours));
		
	
	// back track..
	move_count--;
	
}
#endif



// find best move sequence
//
// if move results in no change, ignore and don't add.
//
// otherwise try it and see if it less moves to complete, if not try another value
//
// each time go back a move and try another, if this results in better moves, keep it.
// go back only when we have tried all moves.


// using best we got 26 moves initially.
// for each we should rate according to best, then choose next best etc
//
// x moves, x bests
// this takes a CRAZY amount of time
int find_min_moves()
{
    char infected;
    int move_wanted = cur_value;
    int s;
	int init_cur_value = cur_value;
	int nvirusbegin;
	
	// reset move count
	move_count = 0;
	
	// perform initial infection using current square, this is the first move given to you
    do
    {
        infected = update_infections();
    }
    while (infected!=0);

    nvirusbegin = nvirus;
    // best could be 5 or 6 for initial

	do
	{
        int best_infected = -1;
        int best_move = -1;

        for (move_wanted=0; move_wanted<num_colours; move_wanted++)
        {
            int total_infected;
            int nvirusbefore = nvirus;

		// skip if this is our current value
             if (move_wanted==cur_value)
                    continue;

            // set the new move
            cur_value = move_wanted;

	     // count infections
            total_infected = 0;

            // update the infection until it's done
            // count the number of moves as it does it.
            do
            {
                infected = update_infections();
                if (infected!=0)
                {
                    total_infected++;
                }
            }
            while (infected!=0);

		// undo this move
             while (nvirus!=nvirusbefore)
            {
                remove_last_pos();
            }
	    
            if ((best_infected==-1) || (total_infected>best_infected))
            {
		    // best so far
                best_infected = total_infected;
                best_move = cur_value;
            }
        }
        
        // update infection
        cur_value = best_move;
        do
        {
            infected = update_infections();
        }
        while (infected!=0);
	
	// this move is good, store it.
        move_sequence[move_count] = best_move;
        ++move_count;
	
	// keep going until all are infected
	}
	while (nvirus!=grid_total);
	
	// now we found our best moves, we need to go back and undo all the moves
	
	// restore initial value
	cur_value = init_cur_value;
	
	// not the best undo this move.
	while (nvirus!=nvirusbegin)
	{
		remove_last_pos();
	}
	
	return move_count;
}
#endif

/***************************************************************/
#define TILE_TYPE_SCR_ADDR SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(MAIN_MENU_CX+11),SCR_CHAR_TO_LINEY0(MAIN_MENU_CY+2))
#define COLOUR_TYPE_SCR_ADDR SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(MAIN_MENU_CX+11),SCR_CHAR_TO_LINEY0(MAIN_MENU_CY+3))

/* on plus we set a raster interrupt up to do the border at the top and bottom */
/* on cpc we can use playcity to do that  and use the cursor and nmi */

void setBorders()
{
  if (plus_PreDetect())
  {
    
  }
  else
  {
      if (playCity_PreDetect())
      {
        
        
      }
    }
  }
  
  void clearBorders()
  {
  if (plus_PreDetect())
  {
    
  }
  else
  {
      if (playCity_PreDetect())
      {
        
        
      }
    }
  }

/***************************************************************/
void sub_state_instructions()
{
	int doing_instructions = 1;

	cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));
	cpc_ClearRectangle(SCR_ADDR_FROM_COORD(INSTRUCTIONS_RECT_X,INSTRUCTIONS_RECT_Y),INSTRUCTIONS_RECT_WIDTH_BYTES,INSTRUCTIONS_RECT_HEIGHT,CLR_COLOUR);

	cpc_SetLetterPens(yellow_pens);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(INSTRUCTIONS_RECT_CX+1),SCR_CHAR_TO_LINEY0(INSTRUCTIONS_RECT_CY+1)), Instructions);

	while (doing_instructions)
	{
		wait_vsync();
		update_input();

		if (SelectPressed())
		{
			doing_instructions = 0;
			state = SUB_STATE_MAIN_MENU;
		}
	}
}
  
  
/***************************************************************/
void sub_state_play_menu()
{
	int donemenu = 0;
  int item = 0;

  cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));

  cpc_ClearRectangle(MAIN_MENU_SCR_ADDR,MAIN_MENU_RECT_WIDTH_BYTES,PLAY_MENU_RECT_HEIGHT,CLR_COLOUR);
	

  cpc_ClearRectangle(SCR_ADDR_FROM_COORD(INSTRUCTIONS_RECT_X,INSTRUCTIONS_RECT_Y),INSTRUCTIONS_RECT_WIDTH_BYTES,INSTRUCTIONS_RECT_HEIGHT,CLR_COLOUR);

	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(INSTRUCTIONS_RECT_CX+1),SCR_CHAR_TO_LINEY0(INSTRUCTIONS_RECT_CY+1)), Instructions);

#ifdef OTHER_TILES

	initmenu(ARRAY_COUNT(PlayMenu),PlayMenu,MAIN_MENU_CX,MAIN_MENU_CY);
  display_tile_options(TILE_TYPE_SCR_ADDR);
  display_colour_options(COLOUR_TYPE_SCR_ADDR);
  
	donemenu = 0;
	while (donemenu==0)
	{
		item = continuemenu(ARRAY_COUNT(PlayMenu),MAIN_MENU_CX,MAIN_MENU_CY,item);
	
		switch (item)
		{

			/* tile type */
			case 1:
			{
			cycle_tile_type();
			// tile type
			display_tile_options(TILE_TYPE_SCR_ADDR);
			}
			break;

			/* num colours type */
			case 2:
			{
			cycle_colours_type();
			// tile type
			display_colour_options(COLOUR_TYPE_SCR_ADDR);
			}
			break;

			
	  /* continue */
      case 0:
      {
		set_main_state_game();
		
        // continue
        donemenu = 1;
      }
      break;
      
	  /* back */
      case 3:
      {
		/* back to main menu */
	      set_main_state_frontend();
        donemenu = 1;
      }
      break;
      
			default:
				break;
		}
	}
  #endif
}


/***************************************************************/

void clearLogo()
{
    if (plus)
    {
    
        int i;
	    plus_RegisterPageEnable();
      
      /* for plus we have some sprites pre-defined as a logo */
             /* plus */
      for (i=0; i<LOGO_NUM_SPRITES; i++)
      {
        plus_SetSpriteMag(i, SPRITE_MAG_DISABLE, SPRITE_MAG_DISABLE);
      }
      
      plus_RegisterPageDisable();
    } 
  }
  /***************************************************************/

void putLogo()
{
  if (plus)
  {
      int i;
	plus_RegisterPageEnable();
    /* for plus we have some sprites pre-defined as a logo */
      /* plus */
      for (i=0; i<LOGO_NUM_SPRITES; i++)
      {
        plus_SetSpriteMag(i, SPRITE_MAG_2, SPRITE_MAG_1);
      }
      plus_RegisterPageDisable();
  }
  else
  {
      /* cpc */
    cpc_SprMask0(SCR_ADDR_FROM_COORD(LOGO_X,LOGO_Y), logo, logo_width_bytes, logo_height_lines);
   
  }
     cpc_SetLetterPens(title_pens);
  
cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(TITLE_CX),SCR_CHAR_TO_LINEY0(TITLE_CY)), StringTable[STRING_TABLE_HEXAVIRUS]);

 }
/***************************************************************/

void main_menu_common()
{
	 /* clear to grey */
	cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));

	cpc_ClearRectangle(SCR_ADDR_FROM_COORD(CREDITS_RECT_X,CREDITS_RECT_Y),CREDITS_RECT_WIDTH_BYTES,CREDITS_RECT_HEIGHT,CLR_COLOUR);
	
	cpc_SetLetterPens(red_pens);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CREDITS_CX+1),SCR_CHAR_TO_LINEY0(CREDITS_CY+1)), StringTable[STRING_TABLE_CODE]);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CREDITS_CX+1),SCR_CHAR_TO_LINEY0(CREDITS_CY+2)), StringTable[STRING_TABLE_GFX]);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CREDITS_CX+1),SCR_CHAR_TO_LINEY0(CREDITS_CY+3)), StringTable[STRING_TABLE_SOUND]);

	cpc_SetLetterPens(white_pens);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CREDITS_CX+8),SCR_CHAR_TO_LINEY0(CREDITS_CY+1)), StringTable[STRING_TABLE_ARNOLDEMU]);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CREDITS_CX+8),SCR_CHAR_TO_LINEY0(CREDITS_CY+2)), StringTable[STRING_TABLE_MACDEATH]);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(CREDITS_CX+8),SCR_CHAR_TO_LINEY0(CREDITS_CY+3)), StringTable[STRING_TABLE_MCKLAIN]);
	
	putLogo();
}

/***************************************************************/

void sub_state_main_menu()
{
	int donemenu;
	int item = 0;
 
	main_menu_common();
	
	cpc_ClearRectangle(MAIN_MENU_SCR_ADDR, MAIN_MENU_RECT_WIDTH_BYTES, MAIN_MENU_RECT_HEIGHT,CLR_COLOUR);

	initmenu(ARRAY_COUNT(MainMenu),MainMenu,MAIN_MENU_CX,MAIN_MENU_CY);

	donemenu = 0;
	while (donemenu==0)
	{
		item = continuemenu(ARRAY_COUNT(MainMenu),MAIN_MENU_CX,MAIN_MENU_CY,item);
		clearLogo();
	
		switch (item)
		{

			/* play */
			case 0:
			{
#ifdef OTHER_TILES
				state = SUB_STATE_PLAY_MENU;
#else
				set_main_state_game();
#endif				
				donemenu = 1;
 			}
			break;
			
			
#ifndef OTHER_TILES
			/* instructions */
			case 1:
			{
			 state = SUB_STATE_INSTRUCTIONS;
				donemenu = 1;
			}
			break;
#endif
			
		  /* options */

#ifndef OTHER_TILES
			case 2:
#else
			case 1:
#endif
			{	
		  
			/* return to main menu */
			backstate = SUB_STATE_MAIN_MENU;
			/* execute options */
			state = SUB_STATE_OPTIONS_MENU;
			
			donemenu = 1;
		  }
		  break;
#if CART==0      
		/* quit */
#ifndef OTHER_TILES
		  case 3:
#else
		case 2:
#endif
		  {
			state = SUB_STATE_EXIT_MENU;
			donemenu = 1;
			}
			break;
#endif			
			default:
				break;
		}
	}
}


/***************************************************************/


void set_main_state_frontend()
{
	main_menu_common();
	
	/* main menu music */
	play_sound(0, menu_music);
	
	mainstate = MAIN_STATE_FRONTEND;
	state = SUB_STATE_MAIN_MENU;
}

void set_main_state_game()
{
	mainstate = MAIN_STATE_GAME;
	state = SUB_STATE_LEVEL_INTRO;
}

/***************************************************************/


int display_question(unsigned char *scraddr, int WidthInBytes, int HeightInLines,  int x, int y, const char *sText)
{
	int stringLength = cpc_StringLength(sText);
	int questionX = x+1;
	int questionY = y+1;
	int menuX = questionX;
	int menuY = y+2;
	
	// clear rectangle for question
	cpc_ClearRectangle(scraddr, WidthInBytes, HeightInLines, CLR_COLOUR);
	
	
	// set pens for question
	cpc_SetLetterPens(yellow_pens);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(questionX), SCR_CHAR_TO_LINEY0(questionY)), sText);
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(questionX+stringLength), SCR_CHAR_TO_LINEY0(questionY)), "?");
	
	// show yes/no
	return confirm_menu(menuX, menuY);
}	

/***************************************************************/
#if CART==0
void sub_state_exit_menu()
{
	// exit?
	if (display_question(MAIN_MENU_SCR_ADDR, MAIN_MENU_RECT_WIDTH_BYTES, MAIN_MENU_RECT_HEIGHT, MAIN_MENU_CX,MAIN_MENU_CY, StringTable[STRING_TABLE_EXIT])==0)
	{
		// exit..
		cpc_Reset();
	}
	else
	{
		// back to frontend
		state = SUB_STATE_MAIN_MENU;
	}	
}	
#endif
 
/***************************************************************/
void sub_state_restart_menu()
{
	// restart?
	if (display_question(PAUSE_MENU_SCR_ADDR,PAUSE_MENU_RECT_WIDTH_BYTES,PAUSE_MENU_RECT_HEIGHT, PAUSE_MENU_CX, PAUSE_MENU_CY, StringTable[STRING_TABLE_RESTART])==0)
	  {
		  // restarting
		state = SUB_STATE_RESTART;
	  }
	  else
	  {
		  // go back to game
		state = STATE_BACK_TO_GAME;
	  }
 }

	
/***************************************************************/
void sub_state_quit_menu()
{
	// quit?
	if (display_question(PAUSE_MENU_SCR_ADDR,PAUSE_MENU_RECT_WIDTH_BYTES,PAUSE_MENU_RECT_HEIGHT, PAUSE_MENU_CX, PAUSE_MENU_CY, StringTable[STRING_TABLE_QUIT])==0)
	{
		// we're quitting
		state = SUB_STATE_QUITTING;
	}
	else
	{
		// back to the game
		state = STATE_BACK_TO_GAME;
	}
}

/***************************************************************/

void sub_state_pause_menu()
{
	int item = 0;
	int donemenu = 0;

	cpc_ClearRectangle(PAUSE_MENU_SCR_ADDR,PAUSE_MENU_RECT_WIDTH_BYTES,PAUSE_MENU_RECT_HEIGHT,CLR_COLOUR);
	
	initmenu(ARRAY_COUNT(PauseMenu),PauseMenu,PAUSE_MENU_CX,PAUSE_MENU_CY);

	donemenu = 0;
	while (donemenu==0)
	{
		item = continuemenu(ARRAY_COUNT(PauseMenu),PAUSE_MENU_CX,PAUSE_MENU_CY,item);
	
		switch (item)
		{
            // continue
			case 0:
			{
				state = STATE_BACK_TO_GAME;
				donemenu = 1;
			}
			break;
						
            // restart
            case 1:
            {
				state = SUB_STATE_RESTART_MENU;
				donemenu = 1;
			}
			break;
		
			// options
			case 2:
			{
				backstate = SUB_STATE_PAUSE_MENU;
				state = SUB_STATE_OPTIONS_MENU;
				donemenu = 1;
			}
			break;
							
			// show quit
			case 3:
			{
				state = SUB_STATE_QUIT_MENU;
				donemenu = 1;
			}
			break;
	
		}
	}
}
     
/***************************************************************/

void common_after_game(int success)
{
	const unsigned char *text;
	const unsigned char *questiontext;
	const unsigned char *tileaddr;
	int tileid = 0;

	if (success)
	{
		/* won game */
		play_sound(SOUND_FLAG_ALWAYS|SOUND_FLAG_WAIT_FOR_END, completed_music);
	}
	else	
	{
		/* failed */
		play_sound(SOUND_FLAG_ALWAYS|SOUND_FLAG_WAIT_FOR_END, game_over_music);
	}
		
	if (success)
	{
		tileid = 0;
		text = StringTable[STRING_TABLE_SUCCESS];
		questiontext = StringTable[STRING_TABLE_PLAY_AGAIN];
	}
	else
	{
		tileid = MAX_COLOURS;
		text = StringTable[STRING_TABLE_FAILED];
		questiontext = StringTable[STRING_TABLE_TRY_AGAIN];
	}
	
	cpc_ClearRectangle(AFTER_GAME_MENU_SCR_ADDR,AFTER_GAME_MENU_RECT_WIDTH_BYTES,AFTER_GAME_MENU_RECT_HEIGHT,CLR_COLOUR);

	tileaddr = hexatiles+((unsigned int)tileid*hex_tile_data_size);
	cpc_SprMask0(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(AFTER_GAME_MENU_CX+AFTER_GAME_MENU_RECT_WIDTH-4),SCR_CHAR_TO_LINEY0(AFTER_GAME_MENU_CY)), tileaddr, hex_tile_width_bytes, hex_tile_height);
	
	if (success)
	{
		cpc_SetLetterPens(white_pens);
	}
	else
	{
		cpc_SetLetterPens(red_pens);
	}
	cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(AFTER_GAME_MENU_CX+1),SCR_CHAR_TO_LINEY0(AFTER_GAME_MENU_CY+1)), text);
}


/***************************************************************/
int common_after_game_question(int success)
{
	const unsigned char *questiontext;
	
	if (success)
	{
		questiontext = StringTable[STRING_TABLE_PLAY_AGAIN];
	}
	else
	{
		questiontext = StringTable[STRING_TABLE_TRY_AGAIN];
	}
	
	return display_question(AFTER_GAME_MENU_QUESTION_SCR_ADDR,AFTER_GAME_MENU_QUESTION_RECT_WIDTH_BYTES,AFTER_GAME_MENU_QUESTION_RECT_HEIGHT, AFTER_GAME_MENU_QUESTION_CX, AFTER_GAME_MENU_QUESTION_CY, questiontext);
}


/***************************************************************/
void sub_state_try_again_menu()
{
	common_after_game(0);
	
	if (common_after_game_question(0)==0)
	{
		// restart previous game
		state = SUB_STATE_RESTART_OLD;
	}
	else
	{
		// back to menu
		state = SUB_STATE_QUITTING;
	}
}

/***************************************************************/

void continue_after_win_question_common()
{
	
	if (common_after_game_question(1)==0)
	{
		// restart new
		state = SUB_STATE_RESTART_NEW;
	}
	else
	{
		// back to menu
		state = SUB_STATE_QUITTING;
	}
}

/***************************************************************/

void sub_state_continue_after_win_menu()
{
	common_after_game(1);
	
#ifdef DO_MOVES_REMAINING
	// try again with one less move.
	totalmoves--;
	if (totalmoves==MOVES_MIN)
	{
		cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(AFTER_GAME_MENU_QUESTION_CX+1),SCR_CHAR_TO_LINEY0(AFTER_GAME_MENU_QUESTION_CY)), StringTable[STRING_TABLE_PRESS_SELECT]);
		int nPressed=0;
		
		while (nPressed==0)
		{
			wait_vsync();
			update_input();

			if (SelectPressed())
			{
				nPressed = 1;
			}
		}	
		state = SUB_STATE_QUITTING;
	}
	else
	{
		continue_after_win_question_common();
	}
#else
	continue_after_win_question_common();
#endif

}
  
/***************************************************************/

void main_state_main_menu()
{
	switch (state)
	{
		case SUB_STATE_MAIN_MENU:
		{
			sub_state_main_menu();
		}
		break;
		case SUB_STATE_PLAY_MENU:
		{
			sub_state_play_menu();
		}
		break;
		
#if CART==0
		case SUB_STATE_EXIT_MENU:
		{
			sub_state_exit_menu();
		}
		break;
#endif
		case SUB_STATE_INSTRUCTIONS:
		{
			sub_state_instructions();
		}
		break;
		
		case SUB_STATE_OPTIONS_MENU:
		{
			
		  main_menu_common();
			sub_state_options_menu(MAIN_MENU_CX, MAIN_MENU_CY,MAIN_MENU_SCR_ADDR, MAIN_MENU_RECT_WIDTH_BYTES, MAIN_MENU_RECT_HEIGHT);
		}
		break;
		
		case SUB_STATE_CENTRALISE_SCREEN:
		{
			centralise_screen();
		}
		break;
	}
}

/***************************************************************/

void begin_game_common()
{
	cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));

	draw_legend();

	draw_moves();

	/* draw the grid */
	draw_grid();
	
	draw_legend_item(sel_value);
					
}

void main_state_game()
{
	int game_quit = 0;
	int game_restart;
  int restart_music = 1;

  GameSeed = RandomSeed;
#ifdef COMPUTE_MOVES
	/* compute min moves */
  computeminmoves = 1;
#endif
	
	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
		{
#ifdef DO_MOVES_REMAINING
			totalmoves = MOVES_MAX;
			nminmoves = MOVES_MIN;
#endif
			tilenumsides = 6;
			grid_width = grid_width_hex;
			grid_height = grid_height_hex;
			grid_total = grid_width_hex*grid_height_hex;
		}
		break;
#ifdef OTHER_TILES		
		case TILE_TYPE_TRIANGLE:
		{
//			totalmoves = MOVES_MAX_TRI;
//			minmoves = MOVES_MIN_TRI;
			tilenumsides = 3;
			grid_width = grid_width_tri;
			grid_height = grid_height_tri;
			grid_total = grid_width_tri*grid_height_tri;
		}
		break;

		case TILE_TYPE_RECTANGLE:
		{
	//		totalmoves = MOVES_MAX_RECT;
	//		minmoves = MOVES_MIN_RECT;
			tilenumsides = 4;
			grid_width = grid_width_rect;
			grid_height = grid_height_rect;
			grid_total = grid_width_rect*grid_height_rect;
		}
		break;
#endif
	}		


  while (game_quit==0)
      {
        	game_restart = 0;

	      state = SUB_STATE_LEVEL_INTRO;
        
        while (game_restart==0)
        {
          
          switch (state)
          {

				case SUB_STATE_LEVEL_INTRO:
				{
					set_silence();
#if COMPUTE_MOVES
					// clear screen, display please wait as we create the grid and calc min moves
					cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));
				  
					cpc_SetLetterPens(yellow_pens);

					// please wait
					cpc_ClearRectangle(SCR_ADDR_FROM_COORD(PLEASE_WAIT_RECT_X,PLEASE_WAIT_RECT_Y),PLEASE_WAIT_RECT_WIDTH_BYTES,PLEASE_WAIT_RECT_HEIGHT,CLR_COLOUR);

					cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(PLEASE_WAIT_RECT_CX+1),SCR_CHAR_TO_LINEY0(PLEASE_WAIT_RECT_CY+1)), PleaseWait);
#endif
					
					/* main game */
					new_game();
	
#if COMPUTE_MOVES
					state = SUB_STATE_LEVEL_INTRO2;
#else
			
					state = SUB_STATE_BEGIN_GAME;
#endif
				}
				break;
				
#if COMPUTE_MOVES					
				case SUB_STATE_LEVEL_INTRO2:
				{
					int nPressed = 0;
					int i;
					int x = 0;
					int y = 0;
				
					// clear screen
				  cpc_CLS(CPC_PEN10_MODE0|(CPC_PEN10_MODE0<<1));

				  // display number of possible moves
					cpc_ClearRectangle(SCR_ADDR_FROM_COORD(LEVEL_RECT_X,LEVEL_RECT_Y),LEVEL_RECT_WIDTH_BYTES,LEVEL_RECT_HEIGHT,CLR_COLOUR);

					cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(LEVEL_RECT_CX+1),SCR_CHAR_TO_LINEY0(LEVEL_RECT_CY+1)), CanBeDone);

					setup_moves_string(nminmoves);
					cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(LEVEL_RECT_CX+27),SCR_CHAR_TO_LINEY0(LEVEL_RECT_CY+1)), num_str);

					for (i=0; i<move_count; i++)
					{
						setup_moves_string(move_sequence[i]);
						cpc_DisplayString(SCR_ADDR_FROM_COORD(SCR_CHAR_TO_BYTEX0(x), SCR_CHAR_TO_LINEY0(y)), num_str);
						x+=4;
						if (x>=8)
						{
							x = 0;
							y++;
						}
					}
					
					while (nPressed==0)
					{
					
							wait_vsync();
						update_input();
		
						if (SelectPressed())
						{
							nPressed = 1;
						}
					}

				// play welcome to game sound
				play_sound(SOUND_FLAG_ALWAYS|SOUND_FLAG_WAIT_FOR_END, game_start_music);
				
				state = SUB_STATE_BEGIN_GAME;
				}
				break;
#endif

				case SUB_STATE_BEGIN_GAME:
				{
					begin_game_common();

					// play welcome to game sound
					play_sound(SOUND_FLAG_ALWAYS|SOUND_FLAG_WAIT_FOR_END, game_start_music);
					
					// now do actual game
					play_sound(0, ingame_music);
					
					state = STATE_UPDATE_INFECTION;
				}
				break;
		  
				  /***************************************************************/
				  case SUB_STATE_RESTART_MENU:
				  {
					sub_state_restart_menu();
					}
					break;
		
		/***************************************************************/
		case SUB_STATE_QUIT_MENU:
		{
			sub_state_quit_menu();
		}
		break;
		
		/***************************************************************/
		case SUB_STATE_PAUSE_MENU:
			{
				sub_state_pause_menu();
			}
			break;
				
			/***************************************************************/
case SUB_STATE_OPTIONS_MENU:
			{
				sub_state_options_menu(PAUSE_MENU_CX, PAUSE_MENU_CY,PAUSE_MENU_SCR_ADDR,PAUSE_MENU_RECT_WIDTH_BYTES,PAUSE_MENU_RECT_HEIGHT);
			}
			break;
			
			/***************************************************************/
case SUB_STATE_CENTRALISE_SCREEN:
			{
				centralise_screen();
				begin_game_common();
			}
			break;
			
			/***************************************************************/
case STATE_BACK_TO_GAME:
			{
				begin_game_common();
				state = STATE_WAITING_PLAYER_CHOICE;
		
			}
			break;
			
			/***************************************************************/
case SUB_STATE_TRY_AGAIN:
			{
				sub_state_try_again_menu();
			}
			break;
	case SUB_STATE_CONTINUE_AFTER_WIN:
			{
				sub_state_continue_after_win_menu();
			}
			break;			
		  
            /***************************************************************/
/* wait for player input.
            Possibilities:
            - player chooses colour
            - player quits */
            default:
            case STATE_WAITING_PLAYER_CHOICE:
            {
              handle_input();
            
            }
            break;

           /***************************************************************/
 case STATE_CHANGE_CHOICE:
            {
              /* redraw old */
              draw_legend_item(old_sel_value);
              /* draw new */
              draw_legend_item(sel_value);
            
              state = STATE_WAITING_PLAYER_CHOICE;
            }
            break;
            
            /***************************************************************/
case STATE_SELECT_CHOICE:
            {
              int old_cur_value = cur_value;
              set_colour_choice(sel_value);
              
              /* redraw old */
              draw_legend_item(old_cur_value);

              /* draw new */
              draw_legend_item(cur_value);
	
	#ifndef DO_MOVES_REMAINING
              /* increase number of moves and update the infection */
              nmovescur++;
	#else
		nmovesleft--;
	#endif
                
              draw_moves();
                  
              state = STATE_UPDATE_INFECTION;
            }
            break;
            
            
            /* draw an infected cell. Possibilities:
            - update infection 
            */
            
            /***************************************************************/
case STATE_DRAW_INFECTED_CELL:
            {

              /* draw the infected cell and move on with the infection */
              int index = nvirus-1;
              int x = move_stack_x[index];
              int y = move_stack_y[index];
              
              /* draw gfx */
            redraw_grid_element(x,y);
              
              delay = 50;
              state = STATE_UPDATE_INFECTION_DELAY;
            }
            break;
            
            /* update the infection. Possibilities:
            - infection ends and we go to next player choice
            - infection continues
            - game is over either through all cells being infected, or number of moves exhausted
            */
            
            /***************************************************************/
case STATE_UPDATE_INFECTION_DELAY:
            {
              delay--;
              if (delay==0)
              {
                state = STATE_UPDATE_INFECTION;
              }
            }
            break;

			case SUB_STATE_QUITTING:
			{
				game_restart = 1;
				game_quit = 1;

        /* back to frontend */
        /* back to frontend */
			 	set_main_state_frontend();
			}
			break;
		
		    case SUB_STATE_RESTART_OLD:
			{
				play_sound(0, ingame_music);
				state = SUB_STATE_RESTART;
			}
			break;
			
			case SUB_STATE_RESTART:
			{
				game_restart = 1;
	#ifdef COMPUTE_MOVES
				/* don't compute min moves */
				computeminmoves = 0;
#endif
				}
		break;
   				
      case SUB_STATE_RESTART_NEW:
      {
          play_sound(0, ingame_music);
          /* restart */
          game_restart=1;
          /* starts game with new seed */
          GameSeed = RandomSeed;
	#ifdef COMPUTE_MOVES
	      /*  compute min moves */
      computeminmoves = 1;
	      #endif
      }
      break;
			
           /***************************************************************/
case STATE_UPDATE_INFECTION:
            {
              char infected = update_infections();

              if (infected==0)
              {
#ifndef DO_MOVES_REMAINING					
                if (nvirus==grid_total)
		{

		      /* did we do it within the minimum number of moves? */
			if (nmovescur>nmovesmin)
			{
				/* game over without win */
				state = SUB_STATE_TRY_AGAIN;
                  		play_sound(SOUND_FLAG_ALWAYS|SOUND_FLAG_WAIT_FOR_END, game_over_music);
			}
			else
			{
				/* yes, we won */
				state = SUB_STATE_GAME_WON;
			}
		}
		else
		{
                    /* game not over, go to player choice */
                    state = STATE_WAITING_PLAYER_CHOICE;
                }
		
#else
		 if (nvirus==grid_total)
		{
			/* yes, we won */
			state = SUB_STATE_GAME_WON;
		}
		else if (nmovesleft==0)
		{
			/* game over without win */
			state = SUB_STATE_TRY_AGAIN;
		}
		else
		{
                    /* game not over, go to player choice */
                    state = STATE_WAITING_PLAYER_CHOICE;
                }
#endif
	}
            }
            break;
			
			/***************************************************************/
			case SUB_STATE_GAME_WON:
			{
				state = SUB_STATE_CONTINUE_AFTER_WIN;
 			}
			break;
			
          }
          
        }
     
      }

}

/*-------------------------------------------------------------------------------*/
/* main game */
void main()
{
	CurrentAnalogue = 0;
	PreviousAnalogue = 0;
	AnalogueChanged = 0;
#ifdef TIMER_DEBUG
	timer_active = 0;
#endif
	currentmusic = 0;
	VsyncMark = 0;
	RandomSeed = 0x0aa;
	num_colours = MAX_COLOURS;  
	soundtype = SOUND_TYPE_MUSIC;
	tiletype = TILE_TYPE_HEXAGON;

//	DEBUG_BREAK;

 
	cpc_DisableMaskableInterrupts();
set_silence();
	cpc_InstallIM1Interrupt(interrupt_handler);
	cpc_EnableMaskableInterrupts();

 
	cpc_SetBorderHW(HW_INK_WHITE);
  cpc_SetColoursHW(16, &Pal[0]);
  
	/* set mode 0, disable upper and lower roms */
	cpc_SetMultiFunctionHW(MF_LOWER_ROM_DISABLE|MF_UPPER_ROM_DISABLE|0);
	
	/* draw the grid */

	cpc_InitScrTable();
	cpc_InitMaskTable0();
  cpc_InitKeys();
  
	cpc_SetCRTCRegisters(CRTCRegisters);

	set_main_state_frontend();

	/* initialise default random seed */
	RandomSeed = cpc_GetRRegister();

  /* includes frontend etc */
  while (1==1)
	{
    switch (mainstate)
    {
      case MAIN_STATE_FRONTEND:
      {
        main_state_main_menu();
      }
      break;
	  
	  
      case MAIN_STATE_GAME:
      {
          main_state_game();
        }
        break;

			default:
				break;
     }
  }
}

	
/*-------------------------------------------------------------------------------*/
/* EOF */


