fade_in_plus:
ret

fade_out_plus:
ret

setup_plus_palette:
ld bc,&7fb8
out (c),c
ld de,&6400
ld bc,17*2
ldir
ld bc,&7fa0
out (c),c
ret


setup_plus_sprites:

ld bc,&7fb8
out (c),c

;; clear sprites
ld b,16
ld hl,&6004
sps2:
ld (hl),0
ld a,l
add a,8
ld l,a
djnz sps2

;; setup sprite palette
ld hl,sprite_palette+2 ;; first two bytes are pen 0
ld de,&6422
ld bc,15*2
ldir


SCR_WIDTH_CHARS equ 48
SCR_WIDTH_PIXELS equ (SCR_WIDTH_CHARS*2*8)
HW_SPRITE_WIDTH equ 16
HW_SPRITE_HEIGHT equ 16
LOGO_WIDTH_SPRITES equ 4
LOGO_HEIGHT_SPRITES equ 4
LOGO_NUM_SPRITES equ ((LOGO_WIDTH_SPRITES*LOGO_HEIGHT_SPRITES)-2)
LOGO_SPRITES_MAGX equ 2
LOGO_SPRITES_MAGY equ 1
LOGO_SPRITES_WIDTH equ (LOGO_WIDTH_SPRITES*HW_SPRITE_WIDTH*LOGO_SPRITES_MAGX)
LOGO_SPRITES_Y equ 32
LOGO_SPRITES_X equ ((SCR_WIDTH_PIXELS/2)-(LOGO_SPRITES_WIDTH/2))

SELECT_SPRITE_ID equ 14

;; copy pixel data into sprites
ld b,LOGO_NUM_SPRITES
ld de,logo_spr
ld hl,&4000
c1:
call copy_spr
inc h
djnz c1
ld hl,&4000+(SELECT_SPRITE_ID*256)
ld de,select_spr
call copy_spr

;; setup coordinates for logo
ld b,LOGO_HEIGHT_SPRITES
ld c,LOGO_WIDTH_SPRITES
ld ix,&6000 ;; initial sprite pointer
ld hl,LOGO_SPRITES_X   ;; initial x 
ld de,LOGO_SPRITES_Y  ;; initial y

sps1:
push bc
push hl
push de
sps3:
ld (ix+0),l
ld (ix+1),h
ld (ix+2),e
ld (ix+3),d
xor a
ld (ix+4),a

;; update x coordinate
ld a,l
add a,HW_SPRITE_WIDTH*LOGO_SPRITES_MAGX
ld l,a
ld a,h
adc a,0
ld h,a

;; update sprite pointer
defb &dd
ld a,l
add a,8
defb &dd
ld l,a

dec c
jr nz,sps3

pop de
pop hl

ld a,e
add a,HW_SPRITE_HEIGHT*LOGO_SPRITES_MAGY
ld e,a
ld a,d
adc a,0
ld d,a

pop bc
djnz sps1

ld bc,&7fa0
out (c),c
ret

;;game_palette:
;;include "gfx/bin/plusgamepal.asm"

sprite_palette:
include "gfx/bin/sprpal.asm"

;; HL = sprite pixel addr
;; DE = pixel data
copy_spr:
push bc

	;; address of sprite data

	;; 16x16 = 256. Data packed into nibbles, so half this.
	ld b,256/2
pds1:
	;; first pixel in upper nibble
	ld a,(de)
	ld c,a
	rrca
	rrca
	rrca
	rrca
	ld (hl),a
	inc l
	ld (hl),c
	inc l
	inc de
	djnz pds1
  
  pop bc
	ret

game_pal_plus:

logo_spr:
incbin "gfx/bin/logo_spr.bin"
select_spr:
incbin "gfx/bin/select_spr.bin"
loadscr_plus_palette:
include "gfx/bin/loadscrpluspal.asm"
defw 0
