#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define grid_width_hex 10
#define grid_height_hex 32
	
/***************************************************************/

#define FRAC_DIV 16
#define FRAC_BITS 4
#define X_INC 2
#define X_INC_SHIFT 1
#define Y_INC 2
#define Y_INC_SHIFT 1
#define MAX_COLOURS 7

unsigned char cpc_RandomInRange(int range)
{
		return rand()%(MAX_COLOURS+1);
}

unsigned char grid[grid_height_hex*grid_width_hex];

	void set_grid_value(int x,int y, int v)
	{
		grid[(grid_width_hex*y)+x] = v;
	}
	unsigned char get_grid_value(int x,int y)
	{
		return grid[(grid_width_hex*y)+x];
	}

	void dump_grid()
	{
			
		int x,y;
		
		for (y=0; y<grid_height_hex; y++)
		{
			for (x=0; x<grid_width_hex; x++)
			{
				printf("%02x ", get_grid_value(x,y));
			}
			printf("\n");
		}
	}

	
int grid_width = grid_width_hex;
int grid_height = grid_height_hex;
	
// value noise
void main()
{

	// fill
	{
		int x,y;
		
		for (y=0; y<grid_height; y++)
		{
			for (x=0; x<grid_width; x++)
			{
				set_grid_value(x,y,0x0ff);
			}
		}
	}
	

	// setup grid - ideally do it as a hexagon, but we treat it as a rectangular grid
	{	
		int y = 0;
		while (y<grid_height)
		{
			int x = 0;
			while (x<grid_width)
			{
				set_grid_value(x,y,cpc_RandomInRange(MAX_COLOURS));
					
				if (x==(grid_width-1))
					break;
				
				x  = x + X_INC;
				
				if (x>=grid_width)
				{
					x = grid_width-1;
				}
			}

			if (y==(grid_height-1))
				break;
			y = y+Y_INC;		// needs to be twice the height for hexagon grids
			if (y>=grid_height)
			{
				y = grid_height-1;
			}
		}
	}
dump_grid();
	
	// interpolate
	{
		int x,y;
		
		for (y=0; y<grid_height; y++)
		{
			int yd = y&(Y_INC-1);
			int py = y-yd;
			int ny = py+Y_INC;
			signed int yf = yd<<(FRAC_BITS-Y_INC_SHIFT);

			if (ny>=grid_height)
			{
				ny = grid_height-1;
			}
			printf("py: %d ny %d yf: %f\n",py,ny,(float)yf/(float)FRAC_DIV);
			
			for (x=0; x<grid_width; x++)
			{
				int xd = x&(X_INC-1);
				int px = x-xd;
				int nx = px+X_INC;
				signed int xf = xd<<(FRAC_BITS-X_INC_SHIFT);
		
				if (nx>=grid_width)
				{
					nx = grid_width-1;
				}

				printf("pX: %d nX %d Xf: %f\n",px,nx, (float)xf/(float)FRAC_DIV);
			
				unsigned char val = get_grid_value(x,y);
				if (val==0x0ff)
				{
					signed char corners[4];
					signed char xdiff1, xdiff2;
					signed int xvdiff;
					signed int xv1,xv2;
					signed int v;
							
					corners[0] = get_grid_value(px,py);
					corners[1] = get_grid_value(nx,py);
					corners[2] = get_grid_value(px,ny);
					corners[3] = get_grid_value(nx,ny);
					printf("corners: %d %d %d %d\n",corners[0], corners[1], corners[2], corners[3]);
					
					xdiff1 = corners[1]-corners[0];
					xdiff2 = corners[3]-corners[2];
					

					xv1 = ((signed int)xdiff1*xf)+((signed int)corners[0]<<FRAC_BITS);
					xv2 = ((signed int)xdiff2*xf)+((signed int)corners[2]<<FRAC_BITS);

					xvdiff = xv2-xv1;

					v =(((xvdiff*yf)>>FRAC_BITS)+xv1)>>FRAC_BITS;
					
					set_grid_value(x,y,v&0x0ff);
				}
			}
		}
	}
	
	dump_grid();
}