extern void Line(int sx, int sy, int ex, int ey);
extern void Point(int sx,int sy);
extern void Pen(int p);
extern void Cls();
extern void Paper(int p);
extern void cpc_SwapDoubleBuffer();
extern void cpc_SetHiddenScr(int);
extern void cpc_SetVisibleScr(int);
extern void cpc_SetDoubleBuffer();
extern void cpc_SetScrWriteMode(int);
extern int cpc_GetHiddenScr();
extern void cpc_SetGraphicsWindow(int x1, int y1, int x2, int y2);
extern void cpc_WaitFrameFlyback();

/* install a single fast ticker int */
extern void cpc_InstallFastTicker(void (*pFn)(void));
/* install a single frame flyback  int */
extern void cpc_InstallFrameFlyback(void (*pFn)(void));

#define EVENT_CLASS_ADDRESS_TYPE 0x01
 

typedef struct KL_EVENT_BLOCK
{
		unsigned char event_count;
		unsigned char event_class;
		unsigned char 
/* installs a function to be called when a frame flyback is triggered. */
extern void cpc_fw_kl_new_frame_flyback();
extern void cpc_fw_kl_new_fast_ticker();

typedef enum
{
	AY_REGISTER_A_TONE_L = 0,
	AY_REGISTER_A_TONE_H,
	AY_REGISTER_B_TONE_L,
	AY_REGISTER_B_TONE_H,
	AY_REGISTER_C_TONE_L,
	AY_REGISTER_C_TONE_H,
	AY_REGISTER_NOISE,
	AY_REGISTER_MIXER,
	AY_REGISTER_A_VOL,
	AY_REGISTER_B_VOL,
	AY_REGISTER_C_VOL,
	AY_REGISTER_ENV_L,
	AY_REGISTER_ENV_H,
	AY_REGISTER_ENV_SHAPE,
	AY_REGISTER_PORT_A,
	AY_REGISTER_PORT_B
} AY_REGISTER_INDEX;

#define AY_MIXER_TONE_A_ENABLE 0
#define AY_MIXER_TONE_A_DISABLE (1<<0)
#define AY_MIXER_TONE_B_ENABLE 0
#define AY_MIXER_TONE_B_DISABLE (1<<1)
#define AY_MIXER_TONE_C_ENABLE 0
#define AY_MIXER_TONE_C_DISABLE (1<<2)
#define AY_MIXER_NOISE_A_ENABLE 0
#define AY_MIXER_NOISE_A_DISABLE (1<<3)
#define AY_MIXER_NOISE_B_ENABLE 0
#define AY_MIXER_NOISE_B_DISABLE (1<<4)
#define AY_MIXER_NOISE_C_ENABLE 0
#define AY_MIXER_NOISE_C_DISABLE (1<<5)
#define AY_MIXER_PORT_A_INPUT 0
#define AY_MIXER_PORT_A_OUTPUT (1<<6)
#define AY_MIXER_PORT_B_INPUT 0
#define AY_MIXER_PORT_B_OUTPUT (1<<7)

#define AY_VOL_USE_ENV (1<<4)

#define AY_MIXER_DEFAULT_PORT (AY_MIXER_PORT_A_INPUT|AY_MIXER_PORT_B_INPUT) 

#define AY_MIXER_NO_TONE_OR_NOISE (AY_MIXER_TONE_A_DISABLE|AY_MIXER_TONE_B_DISABLE|AY_MIXER_TONE_C_DISABLE|AY_MIXER_NOISE_A_DISABLE|AY_MIXER_NOISE_B_DISABLE|AY_MIXER_NOISE_C_DISABLE)

/* firmware function MC SOUND REGISTER. Writes data direct to sound chip register */
/* Register index 0-15. See AY-3-8912 hardware documentation. */ 
extern void cpc_fw_mc_sound_register(AY_REGISTER_INDEX RegisterIndex, int data);

#define EVENT_BLOCK_SIZE 10