.module _cpc_DisplayString
.globl _cpc_DisplayString
.globl _cpc_StringLineStart


.include "defs.s"

;;---------------------------------------------------------------------------------------------------------------------------------
.area _CODE

_cpc_DisplayString: 
ld hl,#2
add hl,sp
ld e,(hl)
inc hl
ld d,(hl)
inc hl
;; DE = screen address
ld (_cpc_StringLineStart),de

ld a,(hl)
inc hl
ld h,(hl)
ld l,a
;; HL = string
cds1:
ld a,(hl)		;; end of string?
inc hl
or a 
ret z
cp #10     ;; lf
jr nz,cds2

;; go down next line
ex de,hl
ld hl,(_cpc_StringLineStart)
ld b,#LETTER_HEIGHT
cds3:
call _cpc_NextLineInternal
djnz cds3
ld (_cpc_StringLineStart),hl
ex de,hl

jr cds1

cds2:
push hl
push de
;; A = letter
ld bc,#_font	;pixels for font
sub #' '      ;; first char
ld l,a		
ld h,#0
;; this needs to change if LETTER_HEIGHT is changed
add hl,hl
add hl,hl
add hl,hl	;;8 bytes per char
add hl,bc	;; HL = font address

call encodeLetter
ld hl,#_cpc_LetterBuffer
ex de,hl
call _cpc_PutCharSingle

pop de
;; move across in X
inc de
inc de

pop hl
jr cds1

;;---------------------------------------------------------------------------------------------------------------------------------

encodeLetter:
push de
push iy
ld iy,#_cpc_LetterBuffer
ld b,#8
el1:
push hl

ld e,(hl)
call ColorOp	
ld 0(iy),d
inc iy
call ColorOp
ld 0(iy),d
inc iy

pop hl
inc hl
djnz el1
pop iy
pop de
ret

;;---------------------------------------------------------------------------------------------------------------------------------

ColorOp:
ld d,#0			;; initial byte at end will be result of 2 pixels combined

call ColorOpPixel	;; do pixel 0 
rlc d     ;; shift to make space for pixel 1
jp ColorOpPixel	;; do pixel 1

;;---------------------------------------------------------------------------------------------------------------------------------

ColorOpPixel:
;; shift out pixel into bits 0 and 1 (source)
rlc e
rlc e
;; isolate
ld a,e
and #3
add a,#<_cpc_LetterPens
ld l,a
ld a,#>_cpc_LetterPens
adc a,#0
ld h,a
;; read it and combine with pixel so far
ld a,d
or (hl)
ld d,a
ret

;;---------------------------------------------------------------------------------------------------------------------------------
